searchData={"items":[{"type":"task","title":"mix rephi.new","doc":"Creates a new Rephi application.\n\nIt expects the path of the project as an argument.\n\n    mix rephi.new PATH [--module MODULE] [--app APP]\n\nA project at the given PATH will be created. The application name and module\nname will be retrieved from the path, unless `--module` or `--app` is given.","ref":"Mix.Tasks.Rephi.New.html"},{"type":"task","title":"Options - mix rephi.new","doc":"* `--app` - the name of the OTP application\n\n  * `--module` - the name of the base module in the generated skeleton\n\n  * `--database` - specify the database adapter for Ecto. One of:\n\n      * `postgres` - via https://github.com/elixir-ecto/postgrex (default)\n      * `mysql` - via https://github.com/elixir-ecto/myxql\n      * `mssql` - via https://github.com/livehelpnow/tds\n      * `sqlite3` - via https://github.com/elixir-sqlite/ecto_sqlite3\n\n    Please check the driver docs for more information. Defaults to \"postgres\".\n\n  * `--no-frontend` - do not generate frontend applications\n\n  * `--binary-id` - use `binary_id` as primary key type in Ecto schemas","ref":"Mix.Tasks.Rephi.New.html#module-options"},{"type":"task","title":"Examples - mix rephi.new","doc":"mix rephi.new hello_world\n\nIs equivalent to:\n\n    mix rephi.new hello_world --module HelloWorld","ref":"Mix.Tasks.Rephi.New.html#module-examples"},{"type":"module","title":"Rephi","doc":"Rephi keeps the contexts that define your domain\nand business logic.\n\nContexts are also responsible for managing your data, regardless\nif it comes from the database, an external API or others.","ref":"Rephi.html"},{"type":"module","title":"Rephi.Accounts","doc":"The Accounts context for managing users.\n\nThis module provides functions for user management including\ncreation, retrieval, authentication, and listing users.","ref":"Rephi.Accounts.html"},{"type":"function","title":"Rephi.Accounts.authenticate_user/2","doc":"","ref":"Rephi.Accounts.html#authenticate_user/2"},{"type":"function","title":"Rephi.Accounts.create_user/1","doc":"","ref":"Rephi.Accounts.html#create_user/1"},{"type":"function","title":"Rephi.Accounts.delete_user/1","doc":"Deletes a user.","ref":"Rephi.Accounts.html#delete_user/1"},{"type":"function","title":"Examples - Rephi.Accounts.delete_user/1","doc":"iex> delete_user(user)\n    {:ok, %User{}}\n\n    iex> delete_user(user)\n    {:error, %Ecto.Changeset{}}","ref":"Rephi.Accounts.html#delete_user/1-examples"},{"type":"function","title":"Rephi.Accounts.get_user/1","doc":"","ref":"Rephi.Accounts.html#get_user/1"},{"type":"function","title":"Rephi.Accounts.get_user!/1","doc":"","ref":"Rephi.Accounts.html#get_user!/1"},{"type":"function","title":"Rephi.Accounts.get_user_by_email/1","doc":"","ref":"Rephi.Accounts.html#get_user_by_email/1"},{"type":"function","title":"Rephi.Accounts.list_users/0","doc":"Returns a list of all users with their roles and permissions preloaded.","ref":"Rephi.Accounts.html#list_users/0"},{"type":"function","title":"Examples - Rephi.Accounts.list_users/0","doc":"iex> list_users()\n    [%User{email: \"admin@admin.com\", ...}, ...]","ref":"Rephi.Accounts.html#list_users/0-examples"},{"type":"function","title":"Rephi.Accounts.update_user/2","doc":"Updates a user.","ref":"Rephi.Accounts.html#update_user/2"},{"type":"function","title":"Examples - Rephi.Accounts.update_user/2","doc":"iex> update_user(user, %{field: new_value})\n    {:ok, %User{}}\n\n    iex> update_user(user, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Rephi.Accounts.html#update_user/2-examples"},{"type":"module","title":"Rephi.Accounts.User","doc":"","ref":"Rephi.Accounts.User.html"},{"type":"function","title":"Rephi.Accounts.User.verify_password/2","doc":"","ref":"Rephi.Accounts.User.html#verify_password/2"},{"type":"module","title":"Rephi.Accounts.UserPermission","doc":"","ref":"Rephi.Accounts.UserPermission.html"},{"type":"module","title":"Rephi.Accounts.UserRole","doc":"Junction table schema for user-role assignments.\n\nThis schema represents the many-to-many relationship between users and roles,\nwith additional metadata about when and why the role was assigned.","ref":"Rephi.Accounts.UserRole.html"},{"type":"module","title":"Fields - Rephi.Accounts.UserRole","doc":"* `user_id` - Reference to the user\n  * `role_id` - Reference to the role\n  * `assigned_by` - ID of the user who made the assignment (optional)\n  * `notes` - Optional notes about the assignment","ref":"Rephi.Accounts.UserRole.html#module-fields"},{"type":"module","title":"Constraints - Rephi.Accounts.UserRole","doc":"* Each user can only have a specific role assigned once\n  * Both user_id and role_id must reference valid records","ref":"Rephi.Accounts.UserRole.html#module-constraints"},{"type":"module","title":"Examples - Rephi.Accounts.UserRole","doc":"iex> changeset = UserRole.changeset(%UserRole{}, %{\n    ...>   user_id: 1,\n    ...>   role_id: 2,\n    ...>   assigned_by: 3,\n    ...>   notes: \"Promoted to manager role\"\n    ...> })\n    iex> changeset.valid?\n    true","ref":"Rephi.Accounts.UserRole.html#module-examples"},{"type":"function","title":"Rephi.Accounts.UserRole.changeset/2","doc":"Validates and casts user-role assignment attributes.","ref":"Rephi.Accounts.UserRole.html#changeset/2"},{"type":"function","title":"Required Fields - Rephi.Accounts.UserRole.changeset/2","doc":"* `user_id` - Must reference a valid user\n  * `role_id` - Must reference a valid role","ref":"Rephi.Accounts.UserRole.html#changeset/2-required-fields"},{"type":"function","title":"Validations - Rephi.Accounts.UserRole.changeset/2","doc":"* Ensures unique combination of user_id and role_id\n  * Validates foreign key references","ref":"Rephi.Accounts.UserRole.html#changeset/2-validations"},{"type":"function","title":"Examples - Rephi.Accounts.UserRole.changeset/2","doc":"iex> UserRole.changeset(%UserRole{}, %{user_id: 1, role_id: 2})\n    %Ecto.Changeset{valid?: true}\n\n    iex> UserRole.changeset(%UserRole{}, %{user_id: nil, role_id: nil})\n    %Ecto.Changeset{valid?: false}","ref":"Rephi.Accounts.UserRole.html#changeset/2-examples"},{"type":"module","title":"Rephi.Authorization","doc":"The Authorization context manages roles, permissions, and user authorization.\n\nThis module implements a complete Role-Based Access Control (RBAC) system with\nhierarchical roles and permissions. It provides functions for:\n\n- Role management (CRUD operations)\n- Permission management (CRUD operations)\n- User-role assignments\n- User-permission assignments (direct)\n- Role-permission assignments\n- Role hierarchy management\n- Authorization checks","ref":"Rephi.Authorization.html"},{"type":"module","title":"Examples - Rephi.Authorization","doc":"# Check if user has permission\n    iex> Authorization.can?(user, \"users:edit\")\n    true\n\n    # Check if user has role\n    iex> Authorization.has_role?(user, \"admin\")\n    false\n\n    # Get all user permissions (direct + inherited via roles)\n    iex> Authorization.get_user_permissions(user)\n    [%Permission{slug: \"users:view\"}, %Permission{slug: \"users:create\"}]","ref":"Rephi.Authorization.html#module-examples"},{"type":"module","title":"Role Hierarchy - Rephi.Authorization","doc":"Roles can inherit permissions from parent roles. For example:\n- `admin` role inherits from `manager` role\n- `manager` role inherits from `user` role\n- Users with `admin` role automatically have all `manager` and `user` permissions","ref":"Rephi.Authorization.html#module-role-hierarchy"},{"type":"module","title":"Permission Categories - Rephi.Authorization","doc":"Permissions are organized by domain using colon notation:\n- `users:*` - User management permissions\n- `roles:*` - Role management permissions\n- `permissions:*` - Permission management permissions\n- `system:*` - System administration permissions","ref":"Rephi.Authorization.html#module-permission-categories"},{"type":"function","title":"Rephi.Authorization.assign_parent_role/2","doc":"Assigns a parent role to a child role.","ref":"Rephi.Authorization.html#assign_parent_role/2"},{"type":"function","title":"Rephi.Authorization.assign_permission_to_role/3","doc":"Assigns a permission to a role.","ref":"Rephi.Authorization.html#assign_permission_to_role/3"},{"type":"function","title":"Rephi.Authorization.assign_permission_to_user/3","doc":"Assigns a permission directly to a user.","ref":"Rephi.Authorization.html#assign_permission_to_user/3"},{"type":"function","title":"Rephi.Authorization.assign_role_to_user/3","doc":"Assigns a role to a user.\n\nCreates a relationship between a user and a role, optionally with metadata\nabout who assigned it and why.","ref":"Rephi.Authorization.html#assign_role_to_user/3"},{"type":"function","title":"Parameters - Rephi.Authorization.assign_role_to_user/3","doc":"* `user` - The user struct\n  * `role` - The role struct to assign\n  * `opts` - Optional metadata (assigned_by, notes)","ref":"Rephi.Authorization.html#assign_role_to_user/3-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.assign_role_to_user/3","doc":"iex> Authorization.assign_role_to_user(user, admin_role)\n    {:ok, %UserRole{}}\n\n    iex> Authorization.assign_role_to_user(user, role, %{\n    ...>   assigned_by: current_user.id,\n    ...>   notes: \"Promoted to admin\"\n    ...> })\n    {:ok, %UserRole{notes: \"Promoted to admin\"}}\n\n    iex> Authorization.assign_role_to_user(user, role)  # Already assigned\n    {:error, %Ecto.Changeset{}}","ref":"Rephi.Authorization.html#assign_role_to_user/3-examples"},{"type":"function","title":"Rephi.Authorization.can?/2","doc":"Checks if a user has a specific permission.\n\nThis function checks both direct permissions assigned to the user and\npermissions inherited through roles. It supports hierarchical role inheritance.","ref":"Rephi.Authorization.html#can?/2"},{"type":"function","title":"Parameters - Rephi.Authorization.can?/2","doc":"* `user` - The user struct to check permissions for\n  * `permission` - Either a permission slug (string) or Permission struct","ref":"Rephi.Authorization.html#can?/2-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.can?/2","doc":"iex> Authorization.can?(user, \"users:edit\")\n    true\n\n    iex> Authorization.can?(user, permission_struct)\n    false\n\n    iex> Authorization.can?(nil, \"users:edit\")\n    false\n\n    iex> Authorization.can?(user, nil)\n    false","ref":"Rephi.Authorization.html#can?/2-examples"},{"type":"function","title":"Permission Resolution Order - Rephi.Authorization.can?/2","doc":"1. Check direct user permissions\n2. Check permissions through assigned roles\n3. Check permissions through role hierarchy (parent roles)","ref":"Rephi.Authorization.html#can?/2-permission-resolution-order"},{"type":"function","title":"Rephi.Authorization.can_by?/1","doc":"Flexible authorization check with keyword options.\n\nThis function provides a flexible interface for authorization checks\nusing keyword arguments instead of positional parameters.","ref":"Rephi.Authorization.html#can_by?/1"},{"type":"function","title":"Parameters - Rephi.Authorization.can_by?/1","doc":"* `opts` - Keyword list with authorization options","ref":"Rephi.Authorization.html#can_by?/1-parameters"},{"type":"function","title":"Supported Options - Rephi.Authorization.can_by?/1","doc":"* `user: user, permission: \"permission:slug\"` - Check user permission\n  * `user: user, role: \"role_slug\"` - Check user role","ref":"Rephi.Authorization.html#can_by?/1-supported-options"},{"type":"function","title":"Examples - Rephi.Authorization.can_by?/1","doc":"iex> Authorization.can_by?(user: user, permission: \"users:edit\")\n    true\n\n    iex> Authorization.can_by?(user: user, role: \"admin\")\n    false\n\n    iex> Authorization.can_by?(invalid: \"option\")\n    false","ref":"Rephi.Authorization.html#can_by?/1-examples"},{"type":"function","title":"Rephi.Authorization.create_permission/1","doc":"Creates a new permission.","ref":"Rephi.Authorization.html#create_permission/1"},{"type":"function","title":"Parameters - Rephi.Authorization.create_permission/1","doc":"* `attrs` - A map of permission attributes","ref":"Rephi.Authorization.html#create_permission/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.create_permission/1","doc":"iex> Authorization.create_permission(%{\n    ...>   name: \"Export Users\",\n    ...>   slug: \"users:export\",\n    ...>   description: \"Export user data\"\n    ...> })\n    {:ok, %Permission{name: \"Export Users\", slug: \"users:export\"}}\n\n    iex> Authorization.create_permission(%{name: \"\", slug: \"\"})\n    {:error, %Ecto.Changeset{}}","ref":"Rephi.Authorization.html#create_permission/1-examples"},{"type":"function","title":"Rephi.Authorization.create_role/1","doc":"Creates a new role.","ref":"Rephi.Authorization.html#create_role/1"},{"type":"function","title":"Parameters - Rephi.Authorization.create_role/1","doc":"* `attrs` - A map of role attributes","ref":"Rephi.Authorization.html#create_role/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.create_role/1","doc":"iex> Authorization.create_role(%{name: \"Manager\", slug: \"manager\"})\n    {:ok, %Role{name: \"Manager\", slug: \"manager\"}}\n\n    iex> Authorization.create_role(%{name: \"\", slug: \"\"})\n    {:error, %Ecto.Changeset{}}","ref":"Rephi.Authorization.html#create_role/1-examples"},{"type":"function","title":"Rephi.Authorization.delete_permission/1","doc":"Deletes a permission from the system.\n\nAlso removes all associated role-permission and user-permission assignments.","ref":"Rephi.Authorization.html#delete_permission/1"},{"type":"function","title":"Parameters - Rephi.Authorization.delete_permission/1","doc":"* `permission` - The permission struct to delete","ref":"Rephi.Authorization.html#delete_permission/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.delete_permission/1","doc":"iex> Authorization.delete_permission(permission)\n    {:ok, %Permission{}}\n\n    iex> Authorization.delete_permission(invalid_permission)\n    {:error, %Ecto.Changeset{}}","ref":"Rephi.Authorization.html#delete_permission/1-examples"},{"type":"function","title":"Rephi.Authorization.delete_role/1","doc":"Deletes a role from the system.\n\nAlso removes all associated user-role and role-permission assignments.","ref":"Rephi.Authorization.html#delete_role/1"},{"type":"function","title":"Parameters - Rephi.Authorization.delete_role/1","doc":"* `role` - The role struct to delete","ref":"Rephi.Authorization.html#delete_role/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.delete_role/1","doc":"iex> Authorization.delete_role(role)\n    {:ok, %Role{}}\n\n    iex> Authorization.delete_role(invalid_role)\n    {:error, %Ecto.Changeset{}}","ref":"Rephi.Authorization.html#delete_role/1-examples"},{"type":"function","title":"Rephi.Authorization.get_permission/1","doc":"Gets a single permission by ID, returning nil if not found.","ref":"Rephi.Authorization.html#get_permission/1"},{"type":"function","title":"Parameters - Rephi.Authorization.get_permission/1","doc":"* `id` - The permission ID","ref":"Rephi.Authorization.html#get_permission/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.get_permission/1","doc":"iex> Authorization.get_permission(1)\n    %Permission{id: 1, name: \"View Users\"}\n\n    iex> Authorization.get_permission(999)\n    nil","ref":"Rephi.Authorization.html#get_permission/1-examples"},{"type":"function","title":"Rephi.Authorization.get_permission!/1","doc":"Gets a single permission by ID, raising an exception if not found.","ref":"Rephi.Authorization.html#get_permission!/1"},{"type":"function","title":"Parameters - Rephi.Authorization.get_permission!/1","doc":"* `id` - The permission ID","ref":"Rephi.Authorization.html#get_permission!/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.get_permission!/1","doc":"iex> Authorization.get_permission!(1)\n    %Permission{id: 1, name: \"View Users\", slug: \"users:view\"}\n\n    iex> Authorization.get_permission!(999)\n    ** (Ecto.NoResultsError)","ref":"Rephi.Authorization.html#get_permission!/1-examples"},{"type":"function","title":"Rephi.Authorization.get_permission_by_slug/1","doc":"Gets a permission by its unique slug identifier.","ref":"Rephi.Authorization.html#get_permission_by_slug/1"},{"type":"function","title":"Parameters - Rephi.Authorization.get_permission_by_slug/1","doc":"* `slug` - The permission slug (e.g., \"users:view\", \"roles:create\")","ref":"Rephi.Authorization.html#get_permission_by_slug/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.get_permission_by_slug/1","doc":"iex> Authorization.get_permission_by_slug(\"users:view\")\n    %Permission{slug: \"users:view\", name: \"View Users\"}\n\n    iex> Authorization.get_permission_by_slug(\"nonexistent\")\n    nil","ref":"Rephi.Authorization.html#get_permission_by_slug/1-examples"},{"type":"function","title":"Rephi.Authorization.get_role/1","doc":"Gets a single role by ID, returning nil if not found.","ref":"Rephi.Authorization.html#get_role/1"},{"type":"function","title":"Parameters - Rephi.Authorization.get_role/1","doc":"* `id` - The role ID","ref":"Rephi.Authorization.html#get_role/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.get_role/1","doc":"iex> Authorization.get_role(1)\n    %Role{id: 1, name: \"Admin\"}\n\n    iex> Authorization.get_role(999)\n    nil","ref":"Rephi.Authorization.html#get_role/1-examples"},{"type":"function","title":"Rephi.Authorization.get_role!/1","doc":"Gets a single role by ID, raising an exception if not found.","ref":"Rephi.Authorization.html#get_role!/1"},{"type":"function","title":"Parameters - Rephi.Authorization.get_role!/1","doc":"* `id` - The role ID","ref":"Rephi.Authorization.html#get_role!/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.get_role!/1","doc":"iex> Authorization.get_role!(1)\n    %Role{id: 1, name: \"Admin\"}\n\n    iex> Authorization.get_role!(999)\n    ** (Ecto.NoResultsError)","ref":"Rephi.Authorization.html#get_role!/1-examples"},{"type":"function","title":"Rephi.Authorization.get_role_by_slug/1","doc":"Gets a role by its unique slug identifier.","ref":"Rephi.Authorization.html#get_role_by_slug/1"},{"type":"function","title":"Parameters - Rephi.Authorization.get_role_by_slug/1","doc":"* `slug` - The role slug (e.g., \"admin\", \"user\")","ref":"Rephi.Authorization.html#get_role_by_slug/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.get_role_by_slug/1","doc":"iex> Authorization.get_role_by_slug(\"admin\")\n    %Role{slug: \"admin\", name: \"Administrator\"}\n\n    iex> Authorization.get_role_by_slug(\"nonexistent\")\n    nil","ref":"Rephi.Authorization.html#get_role_by_slug/1-examples"},{"type":"function","title":"Rephi.Authorization.get_role_permissions/1","doc":"Gets all permissions for a role (including inherited permissions).","ref":"Rephi.Authorization.html#get_role_permissions/1"},{"type":"function","title":"Rephi.Authorization.get_user_permissions/1","doc":"Gets all effective permissions for a user.\n\nReturns a deduplicated list of all permissions the user has access to,\nincluding both direct permissions and permissions inherited through roles\nand role hierarchy.","ref":"Rephi.Authorization.html#get_user_permissions/1"},{"type":"function","title":"Parameters - Rephi.Authorization.get_user_permissions/1","doc":"* `user` - The user struct","ref":"Rephi.Authorization.html#get_user_permissions/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.get_user_permissions/1","doc":"iex> Authorization.get_user_permissions(user)\n    [\n      %Permission{slug: \"users:view\", name: \"View Users\"},\n      %Permission{slug: \"users:create\", name: \"Create Users\"},\n      %Permission{slug: \"roles:view\", name: \"View Roles\"}\n    ]","ref":"Rephi.Authorization.html#get_user_permissions/1-examples"},{"type":"function","title":"Permission Sources - Rephi.Authorization.get_user_permissions/1","doc":"1. **Direct permissions**: Permissions assigned directly to the user\n2. **Role permissions**: Permissions assigned to user's roles\n3. **Inherited permissions**: Permissions from parent roles in hierarchy","ref":"Rephi.Authorization.html#get_user_permissions/1-permission-sources"},{"type":"function","title":"Rephi.Authorization.get_user_roles/1","doc":"Gets all roles directly assigned to a user.\n\nThis does not include roles inherited through hierarchy.","ref":"Rephi.Authorization.html#get_user_roles/1"},{"type":"function","title":"Parameters - Rephi.Authorization.get_user_roles/1","doc":"* `user` - The user struct","ref":"Rephi.Authorization.html#get_user_roles/1-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.get_user_roles/1","doc":"iex> Authorization.get_user_roles(user)\n    [%Role{name: \"Manager\", slug: \"manager\"}]","ref":"Rephi.Authorization.html#get_user_roles/1-examples"},{"type":"function","title":"Rephi.Authorization.has_role?/2","doc":"Checks if a user has a specific role assigned.\n\nThis function only checks for direct role assignments, not role inheritance.","ref":"Rephi.Authorization.html#has_role?/2"},{"type":"function","title":"Parameters - Rephi.Authorization.has_role?/2","doc":"* `user` - The user struct to check\n  * `role` - Either a role slug (string) or Role struct","ref":"Rephi.Authorization.html#has_role?/2-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.has_role?/2","doc":"iex> Authorization.has_role?(user, \"admin\")\n    true\n\n    iex> Authorization.has_role?(user, admin_role)\n    false\n\n    iex> Authorization.has_role?(nil, \"admin\")\n    false\n\n    iex> Authorization.has_role?(user, nil)\n    false","ref":"Rephi.Authorization.html#has_role?/2-examples"},{"type":"function","title":"Rephi.Authorization.list_permissions/0","doc":"Returns the list of all permissions in the system.","ref":"Rephi.Authorization.html#list_permissions/0"},{"type":"function","title":"Examples - Rephi.Authorization.list_permissions/0","doc":"iex> Authorization.list_permissions()\n    [\n      %Permission{name: \"View Users\", slug: \"users:view\"},\n      %Permission{name: \"Create Users\", slug: \"users:create\"}\n    ]","ref":"Rephi.Authorization.html#list_permissions/0-examples"},{"type":"function","title":"Rephi.Authorization.list_roles/0","doc":"Returns the list of all roles in the system.","ref":"Rephi.Authorization.html#list_roles/0"},{"type":"function","title":"Examples - Rephi.Authorization.list_roles/0","doc":"iex> Authorization.list_roles()\n    [%Role{name: \"Admin\", slug: \"admin\"}, %Role{name: \"User\", slug: \"user\"}]","ref":"Rephi.Authorization.html#list_roles/0-examples"},{"type":"function","title":"Rephi.Authorization.remove_parent_role/2","doc":"Removes a parent role from a child role.","ref":"Rephi.Authorization.html#remove_parent_role/2"},{"type":"function","title":"Rephi.Authorization.remove_permission_from_role/2","doc":"Removes a permission from a role.","ref":"Rephi.Authorization.html#remove_permission_from_role/2"},{"type":"function","title":"Rephi.Authorization.remove_permission_from_user/2","doc":"Removes a permission from a user.","ref":"Rephi.Authorization.html#remove_permission_from_user/2"},{"type":"function","title":"Rephi.Authorization.remove_role_from_user/2","doc":"Removes a role assignment from a user.","ref":"Rephi.Authorization.html#remove_role_from_user/2"},{"type":"function","title":"Parameters - Rephi.Authorization.remove_role_from_user/2","doc":"* `user` - The user struct\n  * `role` - The role struct to remove","ref":"Rephi.Authorization.html#remove_role_from_user/2-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.remove_role_from_user/2","doc":"iex> Authorization.remove_role_from_user(user, admin_role)\n    {:ok, %UserRole{}}\n\n    iex> Authorization.remove_role_from_user(user, unassigned_role)\n    {:error, :not_found}","ref":"Rephi.Authorization.html#remove_role_from_user/2-examples"},{"type":"function","title":"Rephi.Authorization.role_has_permission?/2","doc":"Checks if a role has a specific permission.\n\nThis function checks both direct permissions assigned to the role and\npermissions inherited through role hierarchy.","ref":"Rephi.Authorization.html#role_has_permission?/2"},{"type":"function","title":"Parameters - Rephi.Authorization.role_has_permission?/2","doc":"* `role` - The role struct to check\n  * `permission` - Either a permission slug (string) or Permission struct","ref":"Rephi.Authorization.html#role_has_permission?/2-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.role_has_permission?/2","doc":"iex> Authorization.role_has_permission?(admin_role, \"users:delete\")\n    true\n\n    iex> Authorization.role_has_permission?(user_role, delete_permission)\n    false\n\n    iex> Authorization.role_has_permission?(role, \"nonexistent:permission\")\n    false","ref":"Rephi.Authorization.html#role_has_permission?/2-examples"},{"type":"function","title":"Permission Resolution - Rephi.Authorization.role_has_permission?/2","doc":"1. Check permissions directly assigned to the role\n2. Check permissions inherited from parent roles (recursive)","ref":"Rephi.Authorization.html#role_has_permission?/2-permission-resolution"},{"type":"function","title":"Rephi.Authorization.update_permission/2","doc":"Updates an existing permission.","ref":"Rephi.Authorization.html#update_permission/2"},{"type":"function","title":"Parameters - Rephi.Authorization.update_permission/2","doc":"* `permission` - The permission struct to update\n  * `attrs` - A map of attributes to update","ref":"Rephi.Authorization.html#update_permission/2-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.update_permission/2","doc":"iex> Authorization.update_permission(permission, %{\n    ...>   description: \"Updated description\"\n    ...> })\n    {:ok, %Permission{description: \"Updated description\"}}\n\n    iex> Authorization.update_permission(permission, %{slug: \"\"})\n    {:error, %Ecto.Changeset{}}","ref":"Rephi.Authorization.html#update_permission/2-examples"},{"type":"function","title":"Rephi.Authorization.update_role/2","doc":"Updates an existing role.","ref":"Rephi.Authorization.html#update_role/2"},{"type":"function","title":"Parameters - Rephi.Authorization.update_role/2","doc":"* `role` - The role struct to update\n  * `attrs` - A map of attributes to update","ref":"Rephi.Authorization.html#update_role/2-parameters"},{"type":"function","title":"Examples - Rephi.Authorization.update_role/2","doc":"iex> Authorization.update_role(role, %{name: \"Senior Manager\"})\n    {:ok, %Role{name: \"Senior Manager\"}}\n\n    iex> Authorization.update_role(role, %{slug: \"\"})\n    {:error, %Ecto.Changeset{}}","ref":"Rephi.Authorization.html#update_role/2-examples"},{"type":"module","title":"Rephi.Authorization.Permission","doc":"Schema and validations for permissions in the authorization system.\n\nPermissions represent granular access rights that can be assigned to roles\nor directly to users. Permissions support hierarchical organization where\nchild permissions can inherit from parent permissions.","ref":"Rephi.Authorization.Permission.html"},{"type":"module","title":"Fields - Rephi.Authorization.Permission","doc":"* `name` - Human-readable permission name (e.g., \"View Users\")\n  * `slug` - Unique identifier using colon notation (e.g., \"users:view\")\n  * `description` - Optional description of what the permission allows\n  * `parent_id` - Optional reference to parent permission for hierarchy","ref":"Rephi.Authorization.Permission.html#module-fields"},{"type":"module","title":"Permission Naming Convention - Rephi.Authorization.Permission","doc":"Permissions use colon notation to organize by domain:\n- `users:view` - View user information\n- `users:create` - Create new users\n- `roles:edit` - Edit role information\n- `system:manage` - System administration","ref":"Rephi.Authorization.Permission.html#module-permission-naming-convention"},{"type":"module","title":"Associations - Rephi.Authorization.Permission","doc":"* `parent` - Parent permission in hierarchy\n  * `children` - Child permissions that inherit from this one\n  * `roles` - Roles that have this permission assigned\n  * `users` - Users who have this permission directly assigned","ref":"Rephi.Authorization.Permission.html#module-associations"},{"type":"module","title":"Examples - Rephi.Authorization.Permission","doc":"iex> changeset = Permission.changeset(%Permission{}, %{\n    ...>   name: \"View Users\",\n    ...>   slug: \"users:view\",\n    ...>   description: \"Allows viewing user profiles and listings\"\n    ...> })\n    iex> changeset.valid?\n    true","ref":"Rephi.Authorization.Permission.html#module-examples"},{"type":"function","title":"Rephi.Authorization.Permission.changeset/2","doc":"Validates and casts permission attributes.","ref":"Rephi.Authorization.Permission.html#changeset/2"},{"type":"function","title":"Required Fields - Rephi.Authorization.Permission.changeset/2","doc":"* `name` - Must be present\n  * `slug` - Must be present and unique","ref":"Rephi.Authorization.Permission.html#changeset/2-required-fields"},{"type":"function","title":"Validations - Rephi.Authorization.Permission.changeset/2","doc":"* `slug` must contain only lowercase letters, numbers, colons, underscores, and hyphens\n  * `slug` must be unique across all permissions\n  * `parent_id` must reference a valid permission if provided","ref":"Rephi.Authorization.Permission.html#changeset/2-validations"},{"type":"function","title":"Examples - Rephi.Authorization.Permission.changeset/2","doc":"iex> Permission.changeset(%Permission{}, %{\n    ...>   name: \"Edit Users\", \n    ...>   slug: \"users:edit\"\n    ...> })\n    %Ecto.Changeset{valid?: true}\n\n    iex> Permission.changeset(%Permission{}, %{name: \"\", slug: \"\"})\n    %Ecto.Changeset{valid?: false}\n\n    iex> Permission.changeset(%Permission{}, %{\n    ...>   name: \"Test\", \n    ...>   slug: \"Invalid Slug!\"\n    ...> })\n    %Ecto.Changeset{valid?: false}","ref":"Rephi.Authorization.Permission.html#changeset/2-examples"},{"type":"module","title":"Rephi.Authorization.Role","doc":"Schema and validations for roles in the authorization system.\n\nRoles represent a collection of permissions that can be assigned to users.\nRoles support hierarchical inheritance, where child roles can inherit \npermissions from parent roles.","ref":"Rephi.Authorization.Role.html"},{"type":"module","title":"Fields - Rephi.Authorization.Role","doc":"* `name` - Human-readable role name (e.g., \"Administrator\")\n  * `slug` - Unique identifier for the role (e.g., \"admin\")\n  * `description` - Optional description of the role's purpose","ref":"Rephi.Authorization.Role.html#module-fields"},{"type":"module","title":"Associations - Rephi.Authorization.Role","doc":"* `permissions` - Permissions directly assigned to this role\n  * `users` - Users who have this role assigned\n  * `parent_roles` - Roles this role inherits from\n  * `child_roles` - Roles that inherit from this role","ref":"Rephi.Authorization.Role.html#module-associations"},{"type":"module","title":"Examples - Rephi.Authorization.Role","doc":"iex> changeset = Role.changeset(%Role{}, %{\n    ...>   name: \"Content Manager\",\n    ...>   slug: \"content_manager\",\n    ...>   description: \"Can manage content and media\"\n    ...> })\n    iex> changeset.valid?\n    true","ref":"Rephi.Authorization.Role.html#module-examples"},{"type":"function","title":"Rephi.Authorization.Role.changeset/2","doc":"Validates and casts role attributes.","ref":"Rephi.Authorization.Role.html#changeset/2"},{"type":"function","title":"Required Fields - Rephi.Authorization.Role.changeset/2","doc":"* `name` - Must be present\n  * `slug` - Must be present and unique","ref":"Rephi.Authorization.Role.html#changeset/2-required-fields"},{"type":"function","title":"Validations - Rephi.Authorization.Role.changeset/2","doc":"* `slug` must contain only lowercase letters, numbers, underscores, and hyphens\n  * `slug` must be unique across all roles","ref":"Rephi.Authorization.Role.html#changeset/2-validations"},{"type":"function","title":"Examples - Rephi.Authorization.Role.changeset/2","doc":"iex> Role.changeset(%Role{}, %{name: \"Admin\", slug: \"admin\"})\n    %Ecto.Changeset{valid?: true}\n\n    iex> Role.changeset(%Role{}, %{name: \"\", slug: \"\"})\n    %Ecto.Changeset{valid?: false}\n\n    iex> Role.changeset(%Role{}, %{name: \"Test\", slug: \"Invalid-Slug!\"})\n    %Ecto.Changeset{valid?: false}","ref":"Rephi.Authorization.Role.html#changeset/2-examples"},{"type":"module","title":"Rephi.Authorization.RolePermission","doc":"","ref":"Rephi.Authorization.RolePermission.html"},{"type":"module","title":"Rephi.Authorization.RoleRole","doc":"","ref":"Rephi.Authorization.RoleRole.html"},{"type":"module","title":"Rephi.Mailer","doc":"","ref":"Rephi.Mailer.html"},{"type":"function","title":"Rephi.Mailer.deliver/2","doc":"Delivers an email.\n\nIf the email is delivered it returns an `{:ok, result}` tuple. If it fails,\nreturns an `{:error, error}` tuple.","ref":"Rephi.Mailer.html#deliver/2"},{"type":"function","title":"Rephi.Mailer.deliver!/2","doc":"Delivers an email, raises on error.\n\nIf the email is delivered, it returns the result. If it fails, it raises\na `DeliveryError`.","ref":"Rephi.Mailer.html#deliver!/2"},{"type":"function","title":"Rephi.Mailer.deliver_many/2","doc":"Delivers a list of emails.\n\nIt accepts a list of `%Swoosh.Email{}` as its first parameter.","ref":"Rephi.Mailer.html#deliver_many/2"},{"type":"module","title":"Rephi.Repo","doc":"","ref":"Rephi.Repo.html"},{"type":"function","title":"Rephi.Repo.aggregate/3","doc":"Callback implementation for  Ecto.Repo.aggregate/3 .","ref":"Rephi.Repo.html#aggregate/3"},{"type":"function","title":"Rephi.Repo.aggregate/4","doc":"Callback implementation for  Ecto.Repo.aggregate/4 .","ref":"Rephi.Repo.html#aggregate/4"},{"type":"function","title":"Rephi.Repo.all/2","doc":"Callback implementation for  Ecto.Repo.all/2 .","ref":"Rephi.Repo.html#all/2"},{"type":"function","title":"Rephi.Repo.checked_out?/0","doc":"Callback implementation for  Ecto.Repo.checked_out?/0 .","ref":"Rephi.Repo.html#checked_out?/0"},{"type":"function","title":"Rephi.Repo.checkout/2","doc":"Callback implementation for  Ecto.Repo.checkout/2 .","ref":"Rephi.Repo.html#checkout/2"},{"type":"function","title":"Rephi.Repo.child_spec/1","doc":"","ref":"Rephi.Repo.html#child_spec/1"},{"type":"function","title":"Rephi.Repo.config/0","doc":"Callback implementation for  Ecto.Repo.config/0 .","ref":"Rephi.Repo.html#config/0"},{"type":"function","title":"Rephi.Repo.default_options/1","doc":"Callback implementation for  Ecto.Repo.default_options/1 .","ref":"Rephi.Repo.html#default_options/1"},{"type":"function","title":"Rephi.Repo.delete/2","doc":"Callback implementation for  Ecto.Repo.delete/2 .","ref":"Rephi.Repo.html#delete/2"},{"type":"function","title":"Rephi.Repo.delete!/2","doc":"Callback implementation for  Ecto.Repo.delete!/2 .","ref":"Rephi.Repo.html#delete!/2"},{"type":"function","title":"Rephi.Repo.delete_all/2","doc":"Callback implementation for  Ecto.Repo.delete_all/2 .","ref":"Rephi.Repo.html#delete_all/2"},{"type":"function","title":"Rephi.Repo.disconnect_all/2","doc":"A convenience function for SQL-based repositories that forces all connections in the\npool to disconnect within the given interval.\n\nSee `Ecto.Adapters.SQL.disconnect_all/3` for more information.","ref":"Rephi.Repo.html#disconnect_all/2"},{"type":"function","title":"Rephi.Repo.exists?/2","doc":"Callback implementation for  Ecto.Repo.exists?/2 .","ref":"Rephi.Repo.html#exists?/2"},{"type":"function","title":"Rephi.Repo.explain/3","doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar\ndepending on the adapter to obtain statistics for the given query.\n\nSee `Ecto.Adapters.SQL.explain/4` for more information.","ref":"Rephi.Repo.html#explain/3"},{"type":"function","title":"Rephi.Repo.get/3","doc":"Callback implementation for  Ecto.Repo.get/3 .","ref":"Rephi.Repo.html#get/3"},{"type":"function","title":"Rephi.Repo.get!/3","doc":"Callback implementation for  Ecto.Repo.get!/3 .","ref":"Rephi.Repo.html#get!/3"},{"type":"function","title":"Rephi.Repo.get_by/3","doc":"Callback implementation for  Ecto.Repo.get_by/3 .","ref":"Rephi.Repo.html#get_by/3"},{"type":"function","title":"Rephi.Repo.get_by!/3","doc":"Callback implementation for  Ecto.Repo.get_by!/3 .","ref":"Rephi.Repo.html#get_by!/3"},{"type":"function","title":"Rephi.Repo.get_dynamic_repo/0","doc":"Callback implementation for  Ecto.Repo.get_dynamic_repo/0 .","ref":"Rephi.Repo.html#get_dynamic_repo/0"},{"type":"function","title":"Rephi.Repo.in_transaction?/0","doc":"Callback implementation for  Ecto.Repo.in_transaction?/0 .","ref":"Rephi.Repo.html#in_transaction?/0"},{"type":"function","title":"Rephi.Repo.insert/2","doc":"Callback implementation for  Ecto.Repo.insert/2 .","ref":"Rephi.Repo.html#insert/2"},{"type":"function","title":"Rephi.Repo.insert!/2","doc":"Callback implementation for  Ecto.Repo.insert!/2 .","ref":"Rephi.Repo.html#insert!/2"},{"type":"function","title":"Rephi.Repo.insert_all/3","doc":"Callback implementation for  Ecto.Repo.insert_all/3 .","ref":"Rephi.Repo.html#insert_all/3"},{"type":"function","title":"Rephi.Repo.insert_or_update/2","doc":"Callback implementation for  Ecto.Repo.insert_or_update/2 .","ref":"Rephi.Repo.html#insert_or_update/2"},{"type":"function","title":"Rephi.Repo.insert_or_update!/2","doc":"Callback implementation for  Ecto.Repo.insert_or_update!/2 .","ref":"Rephi.Repo.html#insert_or_update!/2"},{"type":"function","title":"Rephi.Repo.load/2","doc":"Callback implementation for  Ecto.Repo.load/2 .","ref":"Rephi.Repo.html#load/2"},{"type":"function","title":"Rephi.Repo.one/2","doc":"Callback implementation for  Ecto.Repo.one/2 .","ref":"Rephi.Repo.html#one/2"},{"type":"function","title":"Rephi.Repo.one!/2","doc":"Callback implementation for  Ecto.Repo.one!/2 .","ref":"Rephi.Repo.html#one!/2"},{"type":"function","title":"Rephi.Repo.preload/3","doc":"Callback implementation for  Ecto.Repo.preload/3 .","ref":"Rephi.Repo.html#preload/3"},{"type":"function","title":"Rephi.Repo.prepare_query/3","doc":"Callback implementation for  Ecto.Repo.prepare_query/3 .","ref":"Rephi.Repo.html#prepare_query/3"},{"type":"function","title":"Rephi.Repo.put_dynamic_repo/1","doc":"Callback implementation for  Ecto.Repo.put_dynamic_repo/1 .","ref":"Rephi.Repo.html#put_dynamic_repo/1"},{"type":"function","title":"Rephi.Repo.query/3","doc":"A convenience function for SQL-based repositories that executes the given query.\n\nSee `Ecto.Adapters.SQL.query/4` for more information.","ref":"Rephi.Repo.html#query/3"},{"type":"function","title":"Rephi.Repo.query!/3","doc":"A convenience function for SQL-based repositories that executes the given query.\n\nSee `Ecto.Adapters.SQL.query!/4` for more information.","ref":"Rephi.Repo.html#query!/3"},{"type":"function","title":"Rephi.Repo.query_many/3","doc":"A convenience function for SQL-based repositories that executes the given multi-result query.\n\nSee `Ecto.Adapters.SQL.query_many/4` for more information.","ref":"Rephi.Repo.html#query_many/3"},{"type":"function","title":"Rephi.Repo.query_many!/3","doc":"A convenience function for SQL-based repositories that executes the given multi-result query.\n\nSee `Ecto.Adapters.SQL.query_many!/4` for more information.","ref":"Rephi.Repo.html#query_many!/3"},{"type":"function","title":"Rephi.Repo.reload/2","doc":"Callback implementation for  Ecto.Repo.reload/2 .","ref":"Rephi.Repo.html#reload/2"},{"type":"function","title":"Rephi.Repo.reload!/2","doc":"Callback implementation for  Ecto.Repo.reload!/2 .","ref":"Rephi.Repo.html#reload!/2"},{"type":"function","title":"Rephi.Repo.rollback/1","doc":"Callback implementation for  Ecto.Repo.rollback/1 .","ref":"Rephi.Repo.html#rollback/1"},{"type":"function","title":"Rephi.Repo.start_link/1","doc":"Callback implementation for  Ecto.Repo.start_link/1 .","ref":"Rephi.Repo.html#start_link/1"},{"type":"function","title":"Rephi.Repo.stop/1","doc":"Callback implementation for  Ecto.Repo.stop/1 .","ref":"Rephi.Repo.html#stop/1"},{"type":"function","title":"Rephi.Repo.stream/2","doc":"Callback implementation for  Ecto.Repo.stream/2 .","ref":"Rephi.Repo.html#stream/2"},{"type":"function","title":"Rephi.Repo.to_sql/2","doc":"A convenience function for SQL-based repositories that translates the given query to SQL.\n\nSee `Ecto.Adapters.SQL.to_sql/3` for more information.","ref":"Rephi.Repo.html#to_sql/2"},{"type":"function","title":"Rephi.Repo.transaction/2","doc":"Callback implementation for  Ecto.Repo.transaction/2 .","ref":"Rephi.Repo.html#transaction/2"},{"type":"function","title":"Rephi.Repo.update/2","doc":"Callback implementation for  Ecto.Repo.update/2 .","ref":"Rephi.Repo.html#update/2"},{"type":"function","title":"Rephi.Repo.update!/2","doc":"Callback implementation for  Ecto.Repo.update!/2 .","ref":"Rephi.Repo.html#update!/2"},{"type":"function","title":"Rephi.Repo.update_all/3","doc":"Callback implementation for  Ecto.Repo.update_all/3 .","ref":"Rephi.Repo.html#update_all/3"},{"type":"module","title":"RephiWeb","doc":"The entrypoint for defining your web interface, such\nas controllers, components, channels, and so on.\n\nThis can be used in your application as:\n\n    use RephiWeb, :controller\n    use RephiWeb, :html\n\nThe definitions below will be executed for every controller,\ncomponent, etc, so keep them short and clean, focused\non imports, uses and aliases.\n\nDo NOT define functions inside the quoted expressions\nbelow. Instead, define additional modules and import\nthose modules here.","ref":"RephiWeb.html"},{"type":"macro","title":"RephiWeb.__using__/1","doc":"When used, dispatch to the appropriate controller/live_view/etc.","ref":"RephiWeb.html#__using__/1"},{"type":"function","title":"RephiWeb.channel/0","doc":"","ref":"RephiWeb.html#channel/0"},{"type":"function","title":"RephiWeb.controller/0","doc":"","ref":"RephiWeb.html#controller/0"},{"type":"function","title":"RephiWeb.router/0","doc":"","ref":"RephiWeb.html#router/0"},{"type":"function","title":"RephiWeb.static_paths/0","doc":"","ref":"RephiWeb.html#static_paths/0"},{"type":"function","title":"RephiWeb.verified_routes/0","doc":"","ref":"RephiWeb.html#verified_routes/0"},{"type":"module","title":"RephiWeb.AppController","doc":"","ref":"RephiWeb.AppController.html"},{"type":"function","title":"RephiWeb.AppController.serve_app/2","doc":"","ref":"RephiWeb.AppController.html#serve_app/2"},{"type":"module","title":"RephiWeb.Auth.AuthorizationHelpers","doc":"Helper functions for authorization checks in controllers and views.\n\nThese helpers provide a convenient way to check user permissions and roles\nwithin controller actions and view templates. They automatically handle\ncases where no user is authenticated.","ref":"RephiWeb.Auth.AuthorizationHelpers.html"},{"type":"module","title":"Usage in Controllers - RephiWeb.Auth.AuthorizationHelpers","doc":"defmodule MyAppWeb.UserController do\n      use MyAppWeb, :controller  # Automatically imports these helpers\n\n      def show(conn, %{\"id\" => id}) do\n        if can?(conn, \"users:view\") do\n          # User can view users\n          user = Accounts.get_user!(id)\n          render(conn, :show, user: user)\n        else\n          # Handle unauthorized access\n          conn |> put_status(:forbidden) |> json(%{error: \"Forbidden\"})\n        end\n      end\n    end","ref":"RephiWeb.Auth.AuthorizationHelpers.html#module-usage-in-controllers"},{"type":"module","title":"Usage in Views/Templates - RephiWeb.Auth.AuthorizationHelpers","doc":"# In a template (EEx)\n    <%= if can?(@conn, \"users:edit\") do %>\n       Edit User \n    <% end %>\n\n    <%= if has_role?(@conn, \"admin\") do %>\n       Admin Tools \n    <% end %>","ref":"RephiWeb.Auth.AuthorizationHelpers.html#module-usage-in-views-templates"},{"type":"module","title":"Safe Defaults - RephiWeb.Auth.AuthorizationHelpers","doc":"All functions return `false` when no user is authenticated, making them\nsafe to use without additional nil checks.","ref":"RephiWeb.Auth.AuthorizationHelpers.html#module-safe-defaults"},{"type":"function","title":"RephiWeb.Auth.AuthorizationHelpers.authorize/2","doc":"Authorize action with flexible options.","ref":"RephiWeb.Auth.AuthorizationHelpers.html#authorize/2"},{"type":"function","title":"Examples - RephiWeb.Auth.AuthorizationHelpers.authorize/2","doc":"authorize(conn, permission: \"users:edit\")\n    authorize(conn, role: \"admin\")\n    authorize(conn, any_permission: [\"users:edit\", \"users:create\"])","ref":"RephiWeb.Auth.AuthorizationHelpers.html#authorize/2-examples"},{"type":"function","title":"RephiWeb.Auth.AuthorizationHelpers.can?/2","doc":"Checks if the current user has a specific permission.\n\nReturns `false` if no user is authenticated or if the user lacks the permission.","ref":"RephiWeb.Auth.AuthorizationHelpers.html#can?/2"},{"type":"function","title":"Parameters - RephiWeb.Auth.AuthorizationHelpers.can?/2","doc":"* `conn` - The Plug.Conn struct containing user information\n  * `permission_slug` - The permission slug to check (e.g., \"users:edit\")","ref":"RephiWeb.Auth.AuthorizationHelpers.html#can?/2-parameters"},{"type":"function","title":"Examples - RephiWeb.Auth.AuthorizationHelpers.can?/2","doc":"# In a controller action\n    if can?(conn, \"users:edit\") do\n      # User can edit users\n    end\n\n    # In a view template\n    <%= if can?(@conn, \"roles:create\") do %>\n       Create Role \n    <% end %>","ref":"RephiWeb.Auth.AuthorizationHelpers.html#can?/2-examples"},{"type":"function","title":"Returns - RephiWeb.Auth.AuthorizationHelpers.can?/2","doc":"* `true` - User is authenticated and has the permission\n  * `false` - User is not authenticated or lacks the permission","ref":"RephiWeb.Auth.AuthorizationHelpers.html#can?/2-returns"},{"type":"function","title":"RephiWeb.Auth.AuthorizationHelpers.can_all?/2","doc":"Checks if the current user has all of the given permissions.","ref":"RephiWeb.Auth.AuthorizationHelpers.html#can_all?/2"},{"type":"function","title":"RephiWeb.Auth.AuthorizationHelpers.can_any?/2","doc":"Checks if the current user has any of the given permissions.","ref":"RephiWeb.Auth.AuthorizationHelpers.html#can_any?/2"},{"type":"function","title":"RephiWeb.Auth.AuthorizationHelpers.current_user/1","doc":"Returns the current user or nil.","ref":"RephiWeb.Auth.AuthorizationHelpers.html#current_user/1"},{"type":"function","title":"RephiWeb.Auth.AuthorizationHelpers.current_user_permissions/1","doc":"Gets the current user's permissions.","ref":"RephiWeb.Auth.AuthorizationHelpers.html#current_user_permissions/1"},{"type":"function","title":"RephiWeb.Auth.AuthorizationHelpers.current_user_roles/1","doc":"Gets the current user's roles.","ref":"RephiWeb.Auth.AuthorizationHelpers.html#current_user_roles/1"},{"type":"function","title":"RephiWeb.Auth.AuthorizationHelpers.has_role?/2","doc":"Checks if the current user has a specific role.\n\nReturns `false` if no user is authenticated or if the user doesn't have the role.","ref":"RephiWeb.Auth.AuthorizationHelpers.html#has_role?/2"},{"type":"function","title":"Parameters - RephiWeb.Auth.AuthorizationHelpers.has_role?/2","doc":"* `conn` - The Plug.Conn struct containing user information\n  * `role_slug` - The role slug to check (e.g., \"admin\", \"manager\")","ref":"RephiWeb.Auth.AuthorizationHelpers.html#has_role?/2-parameters"},{"type":"function","title":"Examples - RephiWeb.Auth.AuthorizationHelpers.has_role?/2","doc":"# In a controller action\n    if has_role?(conn, \"admin\") do\n      # User is an admin\n    end\n\n    # In a view template\n    <%= if has_role?(@conn, \"manager\") do %>\n       Manager Dashboard \n    <% end %>","ref":"RephiWeb.Auth.AuthorizationHelpers.html#has_role?/2-examples"},{"type":"function","title":"Returns - RephiWeb.Auth.AuthorizationHelpers.has_role?/2","doc":"* `true` - User is authenticated and has the role\n  * `false` - User is not authenticated or doesn't have the role","ref":"RephiWeb.Auth.AuthorizationHelpers.html#has_role?/2-returns"},{"type":"module","title":"RephiWeb.Auth.AuthorizationPlug","doc":"Phoenix plugs for authorization checks in controllers.\n\nThis module provides various plugs to protect controller actions based on\nuser permissions and roles. The plugs integrate with the authorization\nsystem to check user permissions before allowing access to protected actions.","ref":"RephiWeb.Auth.AuthorizationPlug.html"},{"type":"module","title":"Usage - RephiWeb.Auth.AuthorizationPlug","doc":"Add authorization plugs to your controller:\n\n    defmodule MyAppWeb.UserController do\n      use MyAppWeb, :controller\n\n      # Protect specific actions\n      plug AuthorizationPlug, {:permission, \"users:edit\"} when action in [:edit, :update]\n      plug AuthorizationPlug, {:role, \"admin\"} when action in [:delete]\n\n      # Multiple permission checks\n      plug AuthorizationPlug, {:any_permission, [\"users:create\", \"users:edit\"]}\n      plug AuthorizationPlug, {:all_permissions, [\"users:edit\", \"system:manage\"]}\n\n      # Your controller actions...\n    end","ref":"RephiWeb.Auth.AuthorizationPlug.html#module-usage"},{"type":"module","title":"Response Codes - RephiWeb.Auth.AuthorizationPlug","doc":"- `401 Unauthorized` - User is not authenticated\n- `403 Forbidden` - User is authenticated but lacks required permissions","ref":"RephiWeb.Auth.AuthorizationPlug.html#module-response-codes"},{"type":"function","title":"RephiWeb.Auth.AuthorizationPlug.call/2","doc":"","ref":"RephiWeb.Auth.AuthorizationPlug.html#call/2"},{"type":"function","title":"RephiWeb.Auth.AuthorizationPlug.init/1","doc":"Plug to use in controllers for authorization.\nCall with :init_options set to {:permission, \"permission:slug\"} or {:role, \"role_slug\"}","ref":"RephiWeb.Auth.AuthorizationPlug.html#init/1"},{"type":"function","title":"Examples - RephiWeb.Auth.AuthorizationPlug.init/1","doc":"# In a controller\n    plug RephiWeb.Auth.AuthorizationPlug, {:permission, \"users:edit\"}\n    plug RephiWeb.Auth.AuthorizationPlug, {:role, \"admin\"}\n    plug RephiWeb.Auth.AuthorizationPlug, {:any_permission, [\"users:edit\", \"users:create\"]}\n    plug RephiWeb.Auth.AuthorizationPlug, {:all_permissions, [\"users:edit\", \"system:manage\"]}","ref":"RephiWeb.Auth.AuthorizationPlug.html#init/1-examples"},{"type":"function","title":"RephiWeb.Auth.AuthorizationPlug.require_all_permissions/2","doc":"Ensures the current user has all of the specified permissions.","ref":"RephiWeb.Auth.AuthorizationPlug.html#require_all_permissions/2"},{"type":"function","title":"Examples - RephiWeb.Auth.AuthorizationPlug.require_all_permissions/2","doc":"# In a controller\n    plug RephiWeb.Auth.AuthorizationPlug, :require_all_permissions, [\"users:edit\", \"system:manage\"]","ref":"RephiWeb.Auth.AuthorizationPlug.html#require_all_permissions/2-examples"},{"type":"function","title":"RephiWeb.Auth.AuthorizationPlug.require_any_permission/2","doc":"Ensures the current user has any of the specified permissions.","ref":"RephiWeb.Auth.AuthorizationPlug.html#require_any_permission/2"},{"type":"function","title":"Examples - RephiWeb.Auth.AuthorizationPlug.require_any_permission/2","doc":"# In a controller\n    plug RephiWeb.Auth.AuthorizationPlug, :require_any_permission, [\"users:edit\", \"users:create\"]","ref":"RephiWeb.Auth.AuthorizationPlug.html#require_any_permission/2-examples"},{"type":"function","title":"RephiWeb.Auth.AuthorizationPlug.require_permission/2","doc":"Ensures the current user has the specified permission.\n\nReturns 401 if user is not authenticated, 403 if user lacks the permission.","ref":"RephiWeb.Auth.AuthorizationPlug.html#require_permission/2"},{"type":"function","title":"Parameters - RephiWeb.Auth.AuthorizationPlug.require_permission/2","doc":"* `conn` - The Plug.Conn struct\n  * `permission_slug` - The permission slug to check (e.g., \"users:edit\")","ref":"RephiWeb.Auth.AuthorizationPlug.html#require_permission/2-parameters"},{"type":"function","title":"Examples - RephiWeb.Auth.AuthorizationPlug.require_permission/2","doc":"# Direct function call (not recommended)\n    conn = require_permission(conn, \"users:edit\")\n\n    # Use as plug (recommended)\n    plug AuthorizationPlug, {:permission, \"users:edit\"}","ref":"RephiWeb.Auth.AuthorizationPlug.html#require_permission/2-examples"},{"type":"function","title":"RephiWeb.Auth.AuthorizationPlug.require_role/2","doc":"Ensures the current user has the specified role.","ref":"RephiWeb.Auth.AuthorizationPlug.html#require_role/2"},{"type":"function","title":"Examples - RephiWeb.Auth.AuthorizationPlug.require_role/2","doc":"# In a controller\n    plug RephiWeb.Auth.AuthorizationPlug, :require_role, \"admin\"","ref":"RephiWeb.Auth.AuthorizationPlug.html#require_role/2-examples"},{"type":"module","title":"RephiWeb.Auth.ErrorHandler","doc":"","ref":"RephiWeb.Auth.ErrorHandler.html"},{"type":"function","title":"RephiWeb.Auth.ErrorHandler.auth_error/3","doc":"Callback implementation for  Guardian.Plug.ErrorHandler.auth_error/3 .","ref":"RephiWeb.Auth.ErrorHandler.html#auth_error/3"},{"type":"module","title":"RephiWeb.Auth.Guardian","doc":"Guardian implementation for JWT token management with authorization support.\n\nThis module extends the basic Guardian functionality to include user roles\nand permissions in JWT tokens, enabling client-side authorization checks\nand reducing server round-trips for permission verification.","ref":"RephiWeb.Auth.Guardian.html"},{"type":"module","title":"Token Claims - RephiWeb.Auth.Guardian","doc":"In addition to standard JWT claims, tokens include:\n- `roles` - Array of role slugs the user has assigned\n- `permissions` - Array of all permission slugs the user has (direct + via roles)","ref":"RephiWeb.Auth.Guardian.html#module-token-claims"},{"type":"module","title":"Example Token Claims - RephiWeb.Auth.Guardian","doc":"{\n      \"sub\": \"123\",\n      \"exp\": 1640995200,\n      \"roles\": [\"manager\", \"user\"],\n      \"permissions\": [\"users:view\", \"users:create\", \"roles:view\"]\n    }","ref":"RephiWeb.Auth.Guardian.html#module-example-token-claims"},{"type":"module","title":"Usage - RephiWeb.Auth.Guardian","doc":"# Generate token with enhanced claims\n    {:ok, token, claims} = Guardian.encode_and_sign(user)\n\n    # Extract user from token\n    {:ok, user} = Guardian.resource_from_token(token)","ref":"RephiWeb.Auth.Guardian.html#module-usage"},{"type":"function","title":"RephiWeb.Auth.Guardian.after_encode_and_sign/4","doc":"Callback implementation for  Guardian.after_encode_and_sign/4 .","ref":"RephiWeb.Auth.Guardian.html#after_encode_and_sign/4"},{"type":"function","title":"RephiWeb.Auth.Guardian.after_sign_in/5","doc":"Callback implementation for  Guardian.after_sign_in/5 .","ref":"RephiWeb.Auth.Guardian.html#after_sign_in/5"},{"type":"function","title":"RephiWeb.Auth.Guardian.before_sign_out/3","doc":"Callback implementation for  Guardian.before_sign_out/3 .","ref":"RephiWeb.Auth.Guardian.html#before_sign_out/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.build_claims/3","doc":"Builds additional claims to include roles and permissions in the JWT token.\n\nThis function is automatically called by Guardian when generating tokens.\nIt enriches the standard JWT claims with the user's current roles and\npermissions, enabling client-side authorization checks.","ref":"RephiWeb.Auth.Guardian.html#build_claims/3"},{"type":"function","title":"Parameters - RephiWeb.Auth.Guardian.build_claims/3","doc":"* `claims` - The base JWT claims map\n  * `resource` - The user struct to generate claims for\n  * `_opts` - Additional options (unused)","ref":"RephiWeb.Auth.Guardian.html#build_claims/3-parameters"},{"type":"function","title":"Returns - RephiWeb.Auth.Guardian.build_claims/3","doc":"* `{:ok, enhanced_claims}` - Claims map with roles and permissions added","ref":"RephiWeb.Auth.Guardian.html#build_claims/3-returns"},{"type":"function","title":"Example - RephiWeb.Auth.Guardian.build_claims/3","doc":"# Before: %{\"sub\" => \"123\", \"exp\" => 1640995200}\n    # After:  %{\n    #   \"sub\" => \"123\", \n    #   \"exp\" => 1640995200,\n    #   \"roles\" => [\"admin\"],\n    #   \"permissions\" => [\"users:view\", \"users:create\", \"roles:manage\"]\n    # }","ref":"RephiWeb.Auth.Guardian.html#build_claims/3-example"},{"type":"function","title":"RephiWeb.Auth.Guardian.config/0","doc":"Fetches the configuration for this module.","ref":"RephiWeb.Auth.Guardian.html#config/0"},{"type":"function","title":"RephiWeb.Auth.Guardian.config/2","doc":"Returns a resolved value of the configuration found at a key.\n\nSee `Guardian.Config.resolve_value/1`.","ref":"RephiWeb.Auth.Guardian.html#config/2"},{"type":"function","title":"RephiWeb.Auth.Guardian.decode_and_verify/3","doc":"Decodes and verifies a token using the configuration on the implementation\nmodule.\n\nSee `Guardian.decode_and_verify/4`.","ref":"RephiWeb.Auth.Guardian.html#decode_and_verify/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.default_token_type/0","doc":"The default type of token for this module.","ref":"RephiWeb.Auth.Guardian.html#default_token_type/0"},{"type":"function","title":"RephiWeb.Auth.Guardian.encode_and_sign/3","doc":"Encodes the claims.\n\nSee `Guardian.encode_and_sign/4` for more information.","ref":"RephiWeb.Auth.Guardian.html#encode_and_sign/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.exchange/4","doc":"Exchanges a token of one type for another.\n\nSee `Guardian.exchange` for more information.","ref":"RephiWeb.Auth.Guardian.html#exchange/4"},{"type":"function","title":"RephiWeb.Auth.Guardian.on_exchange/3","doc":"Callback implementation for  Guardian.on_exchange/3 .","ref":"RephiWeb.Auth.Guardian.html#on_exchange/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.on_refresh/3","doc":"Callback implementation for  Guardian.on_refresh/3 .","ref":"RephiWeb.Auth.Guardian.html#on_refresh/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.on_revoke/3","doc":"Callback implementation for  Guardian.on_revoke/3 .","ref":"RephiWeb.Auth.Guardian.html#on_revoke/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.on_verify/3","doc":"Callback implementation for  Guardian.on_verify/3 .","ref":"RephiWeb.Auth.Guardian.html#on_verify/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.peek/1","doc":"Provides the content of the token but without verification\nof either the claims or the signature.\n\nClaims will be present at the `:claims` key.\n\nSee `Guardian.peek/2` for more information.","ref":"RephiWeb.Auth.Guardian.html#peek/1"},{"type":"function","title":"RephiWeb.Auth.Guardian.refresh/2","doc":"Refresh a token.\n\nSee `Guardian.refresh` for more information.","ref":"RephiWeb.Auth.Guardian.html#refresh/2"},{"type":"function","title":"RephiWeb.Auth.Guardian.resource_from_claims/1","doc":"Callback implementation for  Guardian.resource_from_claims/1 .","ref":"RephiWeb.Auth.Guardian.html#resource_from_claims/1"},{"type":"function","title":"RephiWeb.Auth.Guardian.resource_from_token/3","doc":"Fetch the resource and claims directly from a token.\n\nSee `Guardian.resource_from_token` for more information.","ref":"RephiWeb.Auth.Guardian.html#resource_from_token/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.revoke/2","doc":"Revoke a token.\n\nSee `Guardian.revoke` for more information.","ref":"RephiWeb.Auth.Guardian.html#revoke/2"},{"type":"function","title":"RephiWeb.Auth.Guardian.sliding_cookie/3","doc":"If Guardian.Plug.SlidingCookie is used, this callback will be invoked to\nreturn the new claims, or an error (which will mean the cookie will not\nbe refreshed).","ref":"RephiWeb.Auth.Guardian.html#sliding_cookie/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.subject_for_token/2","doc":"Callback implementation for  Guardian.subject_for_token/2 .","ref":"RephiWeb.Auth.Guardian.html#subject_for_token/2"},{"type":"function","title":"RephiWeb.Auth.Guardian.verify_claims/2","doc":"Callback implementation for  Guardian.verify_claims/2 .","ref":"RephiWeb.Auth.Guardian.html#verify_claims/2"},{"type":"module","title":"RephiWeb.Auth.Guardian.Plug","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.authenticated?/2","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#authenticated?/2"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.clear_remember_me/2","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#clear_remember_me/2"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.current_claims/2","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#current_claims/2"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.current_resource/2","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#current_resource/2"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.current_token/2","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#current_token/2"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.implementation/0","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#implementation/0"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.put_current_claims/3","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#put_current_claims/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.put_current_resource/3","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#put_current_resource/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.put_current_token/3","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#put_current_token/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.put_session_token/3","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#put_session_token/3"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.remember_me/4","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#remember_me/4"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.remember_me_from_token/4","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#remember_me_from_token/4"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.sign_in/4","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#sign_in/4"},{"type":"function","title":"RephiWeb.Auth.Guardian.Plug.sign_out/2","doc":"","ref":"RephiWeb.Auth.Guardian.Plug.html#sign_out/2"},{"type":"module","title":"RephiWeb.Auth.Pipeline","doc":"","ref":"RephiWeb.Auth.Pipeline.html"},{"type":"function","title":"RephiWeb.Auth.Pipeline.assign_current_user/2","doc":"","ref":"RephiWeb.Auth.Pipeline.html#assign_current_user/2"},{"type":"function","title":"RephiWeb.Auth.Pipeline.call/2","doc":"Callback implementation for  Plug.call/2 .","ref":"RephiWeb.Auth.Pipeline.html#call/2"},{"type":"function","title":"RephiWeb.Auth.Pipeline.init/1","doc":"Callback implementation for  Plug.init/1 .","ref":"RephiWeb.Auth.Pipeline.html#init/1"},{"type":"module","title":"RephiWeb.AuthController","doc":"","ref":"RephiWeb.AuthController.html"},{"type":"function","title":"RephiWeb.AuthController.login/2","doc":"","ref":"RephiWeb.AuthController.html#login/2"},{"type":"function","title":"RephiWeb.AuthController.me/2","doc":"","ref":"RephiWeb.AuthController.html#me/2"},{"type":"function","title":"RephiWeb.AuthController.register/2","doc":"","ref":"RephiWeb.AuthController.html#register/2"},{"type":"function","title":"RephiWeb.AuthController.swagger_definitions/0","doc":"","ref":"RephiWeb.AuthController.html#swagger_definitions/0"},{"type":"function","title":"RephiWeb.AuthController.swagger_path_login/1","doc":"","ref":"RephiWeb.AuthController.html#swagger_path_login/1"},{"type":"function","title":"RephiWeb.AuthController.swagger_path_me/1","doc":"","ref":"RephiWeb.AuthController.html#swagger_path_me/1"},{"type":"function","title":"RephiWeb.AuthController.swagger_path_register/1","doc":"","ref":"RephiWeb.AuthController.html#swagger_path_register/1"},{"type":"module","title":"RephiWeb.Endpoint","doc":"","ref":"RephiWeb.Endpoint.html"},{"type":"function","title":"RephiWeb.Endpoint.broadcast/3","doc":"Callback implementation for  Phoenix.Endpoint.broadcast/3 .","ref":"RephiWeb.Endpoint.html#broadcast/3"},{"type":"function","title":"RephiWeb.Endpoint.broadcast!/3","doc":"Callback implementation for  Phoenix.Endpoint.broadcast!/3 .","ref":"RephiWeb.Endpoint.html#broadcast!/3"},{"type":"function","title":"RephiWeb.Endpoint.broadcast_from/4","doc":"Callback implementation for  Phoenix.Endpoint.broadcast_from/4 .","ref":"RephiWeb.Endpoint.html#broadcast_from/4"},{"type":"function","title":"RephiWeb.Endpoint.broadcast_from!/4","doc":"Callback implementation for  Phoenix.Endpoint.broadcast_from!/4 .","ref":"RephiWeb.Endpoint.html#broadcast_from!/4"},{"type":"function","title":"RephiWeb.Endpoint.call/2","doc":"Callback implementation for  Plug.call/2 .","ref":"RephiWeb.Endpoint.html#call/2"},{"type":"function","title":"RephiWeb.Endpoint.child_spec/1","doc":"Returns the child specification to start the endpoint\nunder a supervision tree.","ref":"RephiWeb.Endpoint.html#child_spec/1"},{"type":"function","title":"RephiWeb.Endpoint.config/2","doc":"Returns the endpoint configuration for `key`\n\nReturns `default` if the key does not exist.","ref":"RephiWeb.Endpoint.html#config/2"},{"type":"function","title":"RephiWeb.Endpoint.config_change/2","doc":"Reloads the configuration given the application environment changes.","ref":"RephiWeb.Endpoint.html#config_change/2"},{"type":"function","title":"RephiWeb.Endpoint.host/0","doc":"Returns the host for the given endpoint.","ref":"RephiWeb.Endpoint.html#host/0"},{"type":"function","title":"RephiWeb.Endpoint.init/1","doc":"Callback implementation for  Plug.init/1 .","ref":"RephiWeb.Endpoint.html#init/1"},{"type":"function","title":"RephiWeb.Endpoint.local_broadcast/3","doc":"Callback implementation for  Phoenix.Endpoint.local_broadcast/3 .","ref":"RephiWeb.Endpoint.html#local_broadcast/3"},{"type":"function","title":"RephiWeb.Endpoint.local_broadcast_from/4","doc":"Callback implementation for  Phoenix.Endpoint.local_broadcast_from/4 .","ref":"RephiWeb.Endpoint.html#local_broadcast_from/4"},{"type":"function","title":"RephiWeb.Endpoint.path/1","doc":"Generates the path information when routing to this endpoint.","ref":"RephiWeb.Endpoint.html#path/1"},{"type":"function","title":"RephiWeb.Endpoint.script_name/0","doc":"Generates the script name.","ref":"RephiWeb.Endpoint.html#script_name/0"},{"type":"function","title":"RephiWeb.Endpoint.server_info/1","doc":"Returns the address and port that the server is running on","ref":"RephiWeb.Endpoint.html#server_info/1"},{"type":"function","title":"RephiWeb.Endpoint.start_link/1","doc":"Starts the endpoint supervision tree.\n\nAll other options are merged into the endpoint configuration.","ref":"RephiWeb.Endpoint.html#start_link/1"},{"type":"function","title":"RephiWeb.Endpoint.static_integrity/1","doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file\nin `priv/static`. Meant to be used for Subresource Integrity with CDNs.","ref":"RephiWeb.Endpoint.html#static_integrity/1"},{"type":"function","title":"RephiWeb.Endpoint.static_lookup/1","doc":"Returns a two item tuple with the first item being the `static_path`\nand the second item being the `static_integrity`.","ref":"RephiWeb.Endpoint.html#static_lookup/1"},{"type":"function","title":"RephiWeb.Endpoint.static_path/1","doc":"Generates a route to a static file in `priv/static`.","ref":"RephiWeb.Endpoint.html#static_path/1"},{"type":"function","title":"RephiWeb.Endpoint.static_url/0","doc":"Generates the static URL without any path information.\n\nIt uses the configuration under `:static_url` to generate\nsuch. It falls back to `:url` if `:static_url` is not set.","ref":"RephiWeb.Endpoint.html#static_url/0"},{"type":"function","title":"RephiWeb.Endpoint.struct_url/0","doc":"Generates the endpoint base URL but as a `URI` struct.\n\nIt uses the configuration under `:url` to generate such.\nUseful for manipulating the URL data and passing it to\nURL helpers.","ref":"RephiWeb.Endpoint.html#struct_url/0"},{"type":"function","title":"RephiWeb.Endpoint.subscribe/2","doc":"Callback implementation for  Phoenix.Endpoint.subscribe/2 .","ref":"RephiWeb.Endpoint.html#subscribe/2"},{"type":"function","title":"RephiWeb.Endpoint.unsubscribe/1","doc":"Callback implementation for  Phoenix.Endpoint.unsubscribe/1 .","ref":"RephiWeb.Endpoint.html#unsubscribe/1"},{"type":"function","title":"RephiWeb.Endpoint.url/0","doc":"Generates the endpoint base URL without any path information.\n\nIt uses the configuration under `:url` to generate such.","ref":"RephiWeb.Endpoint.html#url/0"},{"type":"module","title":"RephiWeb.ErrorHelpers","doc":"Conveniences for formatting and returning error responses.\nProvides consistent error formatting across the application.","ref":"RephiWeb.ErrorHelpers.html"},{"type":"function","title":"RephiWeb.ErrorHelpers.render_bad_request/2","doc":"Returns a bad request error response.","ref":"RephiWeb.ErrorHelpers.html#render_bad_request/2"},{"type":"function","title":"RephiWeb.ErrorHelpers.render_changeset_errors/2","doc":"Returns validation errors from a changeset.","ref":"RephiWeb.ErrorHelpers.html#render_changeset_errors/2"},{"type":"function","title":"RephiWeb.ErrorHelpers.render_error/3","doc":"Returns a standardized error response with a single error message.","ref":"RephiWeb.ErrorHelpers.html#render_error/3"},{"type":"function","title":"RephiWeb.ErrorHelpers.render_errors/3","doc":"Returns a standardized error response with multiple error messages.","ref":"RephiWeb.ErrorHelpers.html#render_errors/3"},{"type":"function","title":"RephiWeb.ErrorHelpers.render_not_found/2","doc":"Returns a not found error response.","ref":"RephiWeb.ErrorHelpers.html#render_not_found/2"},{"type":"function","title":"RephiWeb.ErrorHelpers.render_unauthorized/2","doc":"Returns an unauthorized error response.","ref":"RephiWeb.ErrorHelpers.html#render_unauthorized/2"},{"type":"function","title":"RephiWeb.ErrorHelpers.translate_errors/1","doc":"Translates changeset errors to a map.","ref":"RephiWeb.ErrorHelpers.html#translate_errors/1"},{"type":"module","title":"RephiWeb.ErrorJSON","doc":"This module is invoked by your endpoint in case of errors on JSON requests.\n\nSee config/config.exs.","ref":"RephiWeb.ErrorJSON.html"},{"type":"function","title":"RephiWeb.ErrorJSON.render/2","doc":"","ref":"RephiWeb.ErrorJSON.html#render/2"},{"type":"module","title":"RephiWeb.FallbackController","doc":"","ref":"RephiWeb.FallbackController.html"},{"type":"module","title":"RephiWeb.Gettext","doc":"A module providing Internationalization with a gettext-based API.\n\nBy using [Gettext](https://hexdocs.pm/gettext), your module compiles translations\nthat you can use in your application. To use this Gettext backend module,\ncall `use Gettext` and pass it as an option:\n\n    use Gettext, backend: RephiWeb.Gettext\n\n    # Simple translation\n    gettext(\"Here is the string to translate\")\n\n    # Plural translation\n    ngettext(\"Here is the string to translate\",\n             \"Here are the strings to translate\",\n             3)\n\n    # Domain-based translation\n    dgettext(\"errors\", \"Here is the error message to translate\")\n\nSee the [Gettext Docs](https://hexdocs.pm/gettext) for detailed usage.","ref":"RephiWeb.Gettext.html"},{"type":"function","title":"RephiWeb.Gettext.handle_missing_bindings/2","doc":"Callback implementation for  Gettext.Backend.handle_missing_bindings/2 .","ref":"RephiWeb.Gettext.html#handle_missing_bindings/2"},{"type":"function","title":"RephiWeb.Gettext.handle_missing_plural_translation/7","doc":"Callback implementation for  Gettext.Backend.handle_missing_plural_translation/7 .","ref":"RephiWeb.Gettext.html#handle_missing_plural_translation/7"},{"type":"function","title":"RephiWeb.Gettext.handle_missing_translation/5","doc":"Callback implementation for  Gettext.Backend.handle_missing_translation/5 .","ref":"RephiWeb.Gettext.html#handle_missing_translation/5"},{"type":"module","title":"RephiWeb.NotificationController","doc":"","ref":"RephiWeb.NotificationController.html"},{"type":"function","title":"RephiWeb.NotificationController.broadcast/2","doc":"","ref":"RephiWeb.NotificationController.html#broadcast/2"},{"type":"function","title":"RephiWeb.NotificationController.swagger_definitions/0","doc":"","ref":"RephiWeb.NotificationController.html#swagger_definitions/0"},{"type":"function","title":"RephiWeb.NotificationController.swagger_path_broadcast/1","doc":"","ref":"RephiWeb.NotificationController.html#swagger_path_broadcast/1"},{"type":"module","title":"RephiWeb.PermissionController","doc":"","ref":"RephiWeb.PermissionController.html"},{"type":"function","title":"RephiWeb.PermissionController.assign_to_role/2","doc":"","ref":"RephiWeb.PermissionController.html#assign_to_role/2"},{"type":"function","title":"RephiWeb.PermissionController.create/2","doc":"","ref":"RephiWeb.PermissionController.html#create/2"},{"type":"function","title":"RephiWeb.PermissionController.delete/2","doc":"","ref":"RephiWeb.PermissionController.html#delete/2"},{"type":"function","title":"RephiWeb.PermissionController.index/2","doc":"","ref":"RephiWeb.PermissionController.html#index/2"},{"type":"function","title":"RephiWeb.PermissionController.remove_from_role/2","doc":"","ref":"RephiWeb.PermissionController.html#remove_from_role/2"},{"type":"function","title":"RephiWeb.PermissionController.show/2","doc":"","ref":"RephiWeb.PermissionController.html#show/2"},{"type":"function","title":"RephiWeb.PermissionController.swagger_definitions/0","doc":"","ref":"RephiWeb.PermissionController.html#swagger_definitions/0"},{"type":"function","title":"RephiWeb.PermissionController.swagger_path_assign_to_role/1","doc":"","ref":"RephiWeb.PermissionController.html#swagger_path_assign_to_role/1"},{"type":"function","title":"RephiWeb.PermissionController.swagger_path_create/1","doc":"","ref":"RephiWeb.PermissionController.html#swagger_path_create/1"},{"type":"function","title":"RephiWeb.PermissionController.swagger_path_delete/1","doc":"","ref":"RephiWeb.PermissionController.html#swagger_path_delete/1"},{"type":"function","title":"RephiWeb.PermissionController.swagger_path_index/1","doc":"","ref":"RephiWeb.PermissionController.html#swagger_path_index/1"},{"type":"function","title":"RephiWeb.PermissionController.swagger_path_remove_from_role/1","doc":"","ref":"RephiWeb.PermissionController.html#swagger_path_remove_from_role/1"},{"type":"function","title":"RephiWeb.PermissionController.swagger_path_show/1","doc":"","ref":"RephiWeb.PermissionController.html#swagger_path_show/1"},{"type":"function","title":"RephiWeb.PermissionController.swagger_path_update/1","doc":"","ref":"RephiWeb.PermissionController.html#swagger_path_update/1"},{"type":"function","title":"RephiWeb.PermissionController.update/2","doc":"","ref":"RephiWeb.PermissionController.html#update/2"},{"type":"module","title":"RephiWeb.PermissionJSON","doc":"","ref":"RephiWeb.PermissionJSON.html"},{"type":"function","title":"RephiWeb.PermissionJSON.index/1","doc":"Renders a list of permissions.","ref":"RephiWeb.PermissionJSON.html#index/1"},{"type":"function","title":"RephiWeb.PermissionJSON.show/1","doc":"Renders a single permission.","ref":"RephiWeb.PermissionJSON.html#show/1"},{"type":"module","title":"RephiWeb.RoleController","doc":"Controller for managing roles in the authorization system.\n\nThis controller provides a full REST API for role management, including\nCRUD operations and role assignment to users. All actions are protected\nby appropriate permission checks.","ref":"RephiWeb.RoleController.html"},{"type":"module","title":"Endpoints - RephiWeb.RoleController","doc":"* `GET /api/roles` - List all roles (requires \"roles:view\")\n  * `POST /api/roles` - Create a new role (requires \"roles:create\")\n  * `GET /api/roles/:id` - Get role details (requires \"roles:view\")\n  * `PUT /api/roles/:id` - Update role (requires \"roles:edit\")\n  * `DELETE /api/roles/:id` - Delete role (requires \"roles:delete\")\n  * `POST /api/users/:user_id/roles/:role_id` - Assign role to user (requires \"roles:assign\")\n  * `DELETE /api/users/:user_id/roles/:role_id` - Remove role from user (requires \"roles:assign\")","ref":"RephiWeb.RoleController.html#module-endpoints"},{"type":"module","title":"Permission Requirements - RephiWeb.RoleController","doc":"All actions require authentication and specific permissions:\n- View actions: `roles:view`\n- Create actions: `roles:create`\n- Update actions: `roles:edit`\n- Delete actions: `roles:delete`\n- Assignment actions: `roles:assign`","ref":"RephiWeb.RoleController.html#module-permission-requirements"},{"type":"function","title":"RephiWeb.RoleController.assign_to_user/2","doc":"","ref":"RephiWeb.RoleController.html#assign_to_user/2"},{"type":"function","title":"RephiWeb.RoleController.create/2","doc":"","ref":"RephiWeb.RoleController.html#create/2"},{"type":"function","title":"RephiWeb.RoleController.delete/2","doc":"","ref":"RephiWeb.RoleController.html#delete/2"},{"type":"function","title":"RephiWeb.RoleController.get_role_permissions/2","doc":"","ref":"RephiWeb.RoleController.html#get_role_permissions/2"},{"type":"function","title":"RephiWeb.RoleController.index/2","doc":"","ref":"RephiWeb.RoleController.html#index/2"},{"type":"function","title":"RephiWeb.RoleController.remove_from_user/2","doc":"","ref":"RephiWeb.RoleController.html#remove_from_user/2"},{"type":"function","title":"RephiWeb.RoleController.show/2","doc":"","ref":"RephiWeb.RoleController.html#show/2"},{"type":"function","title":"RephiWeb.RoleController.swagger_definitions/0","doc":"","ref":"RephiWeb.RoleController.html#swagger_definitions/0"},{"type":"function","title":"RephiWeb.RoleController.swagger_path_assign_to_user/1","doc":"","ref":"RephiWeb.RoleController.html#swagger_path_assign_to_user/1"},{"type":"function","title":"RephiWeb.RoleController.swagger_path_create/1","doc":"","ref":"RephiWeb.RoleController.html#swagger_path_create/1"},{"type":"function","title":"RephiWeb.RoleController.swagger_path_delete/1","doc":"","ref":"RephiWeb.RoleController.html#swagger_path_delete/1"},{"type":"function","title":"RephiWeb.RoleController.swagger_path_get_role_permissions/1","doc":"","ref":"RephiWeb.RoleController.html#swagger_path_get_role_permissions/1"},{"type":"function","title":"RephiWeb.RoleController.swagger_path_index/1","doc":"","ref":"RephiWeb.RoleController.html#swagger_path_index/1"},{"type":"function","title":"RephiWeb.RoleController.swagger_path_remove_from_user/1","doc":"","ref":"RephiWeb.RoleController.html#swagger_path_remove_from_user/1"},{"type":"function","title":"RephiWeb.RoleController.swagger_path_show/1","doc":"","ref":"RephiWeb.RoleController.html#swagger_path_show/1"},{"type":"function","title":"RephiWeb.RoleController.swagger_path_update/1","doc":"","ref":"RephiWeb.RoleController.html#swagger_path_update/1"},{"type":"function","title":"RephiWeb.RoleController.update/2","doc":"","ref":"RephiWeb.RoleController.html#update/2"},{"type":"module","title":"RephiWeb.RoleJSON","doc":"","ref":"RephiWeb.RoleJSON.html"},{"type":"function","title":"RephiWeb.RoleJSON.index/1","doc":"Renders a list of roles.","ref":"RephiWeb.RoleJSON.html#index/1"},{"type":"function","title":"RephiWeb.RoleJSON.permissions/1","doc":"Renders role permissions.","ref":"RephiWeb.RoleJSON.html#permissions/1"},{"type":"function","title":"RephiWeb.RoleJSON.show/1","doc":"Renders a single role.","ref":"RephiWeb.RoleJSON.html#show/1"},{"type":"module","title":"RephiWeb.Router","doc":"","ref":"RephiWeb.Router.html"},{"type":"function","title":"RephiWeb.Router.api/2","doc":"","ref":"RephiWeb.Router.html#api/2"},{"type":"function","title":"RephiWeb.Router.authenticated/2","doc":"","ref":"RephiWeb.Router.html#authenticated/2"},{"type":"function","title":"RephiWeb.Router.browser/2","doc":"","ref":"RephiWeb.Router.html#browser/2"},{"type":"function","title":"RephiWeb.Router.call/2","doc":"Callback invoked by Plug on every request.","ref":"RephiWeb.Router.html#call/2"},{"type":"function","title":"RephiWeb.Router.init/1","doc":"Callback required by Plug that initializes the router\nfor serving web requests.","ref":"RephiWeb.Router.html#init/1"},{"type":"function","title":"RephiWeb.Router.swagger_info/0","doc":"","ref":"RephiWeb.Router.html#swagger_info/0"},{"type":"module","title":"RephiWeb.SwaggerController","doc":"","ref":"RephiWeb.SwaggerController.html"},{"type":"function","title":"RephiWeb.SwaggerController.index/2","doc":"","ref":"RephiWeb.SwaggerController.html#index/2"},{"type":"module","title":"RephiWeb.Telemetry","doc":"","ref":"RephiWeb.Telemetry.html"},{"type":"function","title":"RephiWeb.Telemetry.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"RephiWeb.Telemetry.html#child_spec/1"},{"type":"function","title":"RephiWeb.Telemetry.metrics/0","doc":"","ref":"RephiWeb.Telemetry.html#metrics/0"},{"type":"function","title":"RephiWeb.Telemetry.start_link/1","doc":"","ref":"RephiWeb.Telemetry.html#start_link/1"},{"type":"module","title":"RephiWeb.UserChannel","doc":"","ref":"RephiWeb.UserChannel.html"},{"type":"function","title":"RephiWeb.UserChannel.child_spec/1","doc":"","ref":"RephiWeb.UserChannel.html#child_spec/1"},{"type":"function","title":"RephiWeb.UserChannel.start_link/1","doc":"","ref":"RephiWeb.UserChannel.html#start_link/1"},{"type":"module","title":"RephiWeb.UserController","doc":"Controller for user management endpoints.\n\nThis controller handles user-related operations including listing all users.\nAll actions require authentication and specific permissions.","ref":"RephiWeb.UserController.html"},{"type":"module","title":"Endpoints - RephiWeb.UserController","doc":"* `GET /api/users` - List all users (requires admin role)","ref":"RephiWeb.UserController.html#module-endpoints"},{"type":"module","title":"Permission Requirements - RephiWeb.UserController","doc":"All actions require authentication and admin role.","ref":"RephiWeb.UserController.html#module-permission-requirements"},{"type":"function","title":"RephiWeb.UserController.delete/2","doc":"","ref":"RephiWeb.UserController.html#delete/2"},{"type":"function","title":"RephiWeb.UserController.get_user_roles/2","doc":"","ref":"RephiWeb.UserController.html#get_user_roles/2"},{"type":"function","title":"RephiWeb.UserController.index/2","doc":"","ref":"RephiWeb.UserController.html#index/2"},{"type":"function","title":"RephiWeb.UserController.show/2","doc":"","ref":"RephiWeb.UserController.html#show/2"},{"type":"function","title":"RephiWeb.UserController.swagger_definitions/0","doc":"","ref":"RephiWeb.UserController.html#swagger_definitions/0"},{"type":"function","title":"RephiWeb.UserController.swagger_path_delete/1","doc":"Deletes a user.\n\nPermanently removes a user from the system. Only accessible by users with admin role.","ref":"RephiWeb.UserController.html#swagger_path_delete/1"},{"type":"function","title":"RephiWeb.UserController.swagger_path_get_user_roles/1","doc":"Gets roles for a specific user.\n\nReturns a list of roles assigned to the user. Only accessible by users with admin role.","ref":"RephiWeb.UserController.html#swagger_path_get_user_roles/1"},{"type":"function","title":"RephiWeb.UserController.swagger_path_index/1","doc":"Lists all users in the system.\n\nReturns a list of all users with their roles and permissions.\nOnly accessible by users with admin role.","ref":"RephiWeb.UserController.html#swagger_path_index/1"},{"type":"function","title":"RephiWeb.UserController.swagger_path_show/1","doc":"Shows a specific user by ID.\n\nReturns detailed information about a user including roles and permissions.\nOnly accessible by users with admin role.","ref":"RephiWeb.UserController.html#swagger_path_show/1"},{"type":"function","title":"RephiWeb.UserController.swagger_path_update/1","doc":"Updates a user.\n\nAllows updating user information. Only accessible by users with admin role.","ref":"RephiWeb.UserController.html#swagger_path_update/1"},{"type":"function","title":"RephiWeb.UserController.update/2","doc":"","ref":"RephiWeb.UserController.html#update/2"},{"type":"module","title":"RephiWeb.UserJSON","doc":"View module for rendering user data.\n\nThis module handles the JSON rendering of user resources,\nincluding their associated roles and permissions.","ref":"RephiWeb.UserJSON.html"},{"type":"function","title":"RephiWeb.UserJSON.index/1","doc":"Renders a list of users.","ref":"RephiWeb.UserJSON.html#index/1"},{"type":"function","title":"RephiWeb.UserJSON.me_with_auth/1","doc":"Renders current user with roles and permissions.","ref":"RephiWeb.UserJSON.html#me_with_auth/1"},{"type":"function","title":"RephiWeb.UserJSON.roles/1","doc":"Renders user roles.","ref":"RephiWeb.UserJSON.html#roles/1"},{"type":"function","title":"RephiWeb.UserJSON.show/1","doc":"Renders a single user.","ref":"RephiWeb.UserJSON.html#show/1"},{"type":"function","title":"RephiWeb.UserJSON.user_with_token/1","doc":"Renders user with authentication token.","ref":"RephiWeb.UserJSON.html#user_with_token/1"},{"type":"module","title":"RephiWeb.UserSocket","doc":"","ref":"RephiWeb.UserSocket.html"},{"type":"extras","title":"Rephi","doc":"# Rephi\n\nA production-ready Phoenix boilerplate with JWT authentication, RBAC authorization, WebSocket support, and multi-frontend architecture.","ref":"readme.html"},{"type":"extras","title":"🚀 Quick Start - Rephi","doc":"","ref":"readme.html#quick-start"},{"type":"extras","title":"Create a new project using Rephi - Rephi","doc":"1. **Install the Rephi project generator**\n   ```bash\n   mix archive.install hex rephi_new\n   ```\n\n2. **Create your new project**\n   ```bash\n   mix rephi.new my_app\n   cd my_app\n   ```\n\n3. **Configure environment variables**\n   ```bash\n   cp .env.example .env\n   # Edit .env with your database credentials and configuration\n   ```\n\n4. **Setup and run**\n   ```bash\n   mix setup\n   mix phx.server\n   ```\n\n   Visit [`localhost:4000`](http://localhost:4000) from your browser.","ref":"readme.html#create-a-new-project-using-rephi"},{"type":"extras","title":"Prerequisites - Rephi","doc":"- **Elixir** 1.14 or higher\n- **Erlang** 24 or higher\n- **PostgreSQL** 12 or higher\n- **Node.js** 18 or higher\n- **npm** or **yarn**","ref":"readme.html#prerequisites"},{"type":"extras","title":"Features - Rephi","doc":"- **🔐 JWT Authentication**: Secure token-based authentication system\n- **👮 RBAC Authorization**: Complete Role-Based Access Control with hierarchical permissions\n- **🔌 WebSocket Support**: Real-time communication via Phoenix Channels\n- **⚛️ Multi-Frontend Architecture**: Support for multiple React SPAs (dashboard, admin, e-commerce, landing)\n- **📚 API Documentation**: Auto-generated Swagger/OpenAPI documentation\n- **🏗️ Production Ready**: Configured for scalability and best practices\n- **🛡️ CSRF Protection**: Built-in CSRF token injection for SPAs","ref":"readme.html#features"},{"type":"extras","title":"Manual Setup (for development) - Rephi","doc":"1. **Clone the repository**\n   ```bash\n   git clone https://github.com/thotenn/rephi.git\n   cd rephi\n   ```\n\n2. **Install dependencies**\n   ```bash\n   mix deps.get\n   ```\n\n3. **Configure database**\n   ```bash\n   mix ecto.create\n   mix ecto.migrate\n   ```\n\n   Or use the complete setup command:\n   ```bash\n   mix setup\n   ```\n\n4. **Start Phoenix server**\n   ```bash\n   mix phx.server\n   ```\n   \n   Or with interactive shell:\n   ```bash\n   iex -S mix phx.server\n   ```\n\n   Backend will be available at `http://localhost:4000`","ref":"readme.html#manual-setup-for-development"},{"type":"extras","title":"Frontend Development - Rephi","doc":"Each frontend app is a standalone React application:\n\n```bash\ncd apps/dashboard\nnpm install\nnpm run dev\n```","ref":"readme.html#frontend-development"},{"type":"extras","title":"Building Frontends - Rephi","doc":"```bash\n# Build all frontends\nmix frontends.build\n\n# Clean frontend builds\nmix frontends.clean\n```","ref":"readme.html#building-frontends"},{"type":"extras","title":"Architecture - Rephi","doc":"","ref":"readme.html#architecture"},{"type":"extras","title":"Backend Structure - Rephi","doc":"```\nlib/\n├── rephi/              # Core business logic\n│   ├── accounts/       # User management\n│   └── authorization/  # RBAC system\n├── rephi_web/          # Web layer\n│   ├── controllers/    # API controllers\n│   ├── auth/          # Authentication plugs\n│   └── channels/      # WebSocket channels\n```","ref":"readme.html#backend-structure"},{"type":"extras","title":"Frontend Structure - Rephi","doc":"```\napps/\n├── shared/            # Shared React components\n├── dashboard/         # Dashboard SPA\n├── admin/            # Admin panel SPA\n├── ecommerce/        # E-commerce SPA\n└── landing/          # Landing page SPA\n```","ref":"readme.html#frontend-structure"},{"type":"extras","title":"API Documentation - Rephi","doc":"Interactive API documentation is available via Swagger:\n\n- **Swagger UI**: `http://localhost:4000/api/swagger`\n- **Swagger JSON**: `http://localhost:4000/api/swagger/swagger.json`\n\nTo regenerate documentation after changes:\n```bash\nmix phx.swagger.generate\n```","ref":"readme.html#api-documentation"},{"type":"extras","title":"Useful Commands - Rephi","doc":"","ref":"readme.html#useful-commands"},{"type":"extras","title":"Backend - Rephi","doc":"```bash\n# Run tests\nmix test\n\n# Format code\nmix format\n\n# Clean and rebuild\nmix clean && mix compile\n\n# Reset database\nmix ecto.reset\n\n# Generate Swagger documentation\nmix phx.swagger.generate\n```","ref":"readme.html#backend"},{"type":"extras","title":"Frontend - Rephi","doc":"```bash\n# Build for production\nnpm run build\n\n# Run linter\nnpm run lint\n\n# Check TypeScript types\nnpm run typecheck\n\n# Start production server\nnpm start\n```","ref":"readme.html#frontend"},{"type":"extras","title":"Technology Stack - Rephi","doc":"","ref":"readme.html#technology-stack"},{"type":"extras","title":"Backend (Phoenix/Elixir) - Rephi","doc":"- **REST API** under `/api/*`\n- **JWT Authentication** with Guardian\n- **WebSockets** with Phoenix Channels\n- **Database** PostgreSQL with Ecto\n- **Documentation** automatic with Phoenix Swagger","ref":"readme.html#backend-phoenix-elixir"},{"type":"extras","title":"Frontend (React) - Rephi","doc":"- **SPA Mode** without SSR\n- **Global State** with Zustand (persisted)\n- **Forms** with React Hook Form + Zod\n- **Styling** with Tailwind CSS v4\n- **API Client** with Axios","ref":"readme.html#frontend-react"},{"type":"extras","title":"Authorization System - Rephi","doc":"","ref":"readme.html#authorization-system"},{"type":"extras","title":"JWT Authentication - Rephi","doc":"1. Users register/authenticate at `/api/users/register` or `/api/users/login`\n2. JWT is stored in Zustand and localStorage\n3. Axios interceptor automatically adds `Authorization: Bearer {token}` header\n4. Protected endpoints require valid authentication","ref":"readme.html#jwt-authentication"},{"type":"extras","title":"Role-Based Access Control (RBAC) - Rephi","doc":"Rephi includes a complete role-based access control (RBAC) system with the following features:\n\n#### Roles and Hierarchies\n- **Hierarchical roles**: Roles can inherit permissions from other roles\n- **Default roles**: \n  - `admin` → inherits from `manager`\n  - `manager` → inherits from `user`\n  - `user` → basic access\n\n#### Granular Permissions\nPermissions are organized by categories:\n\n- **users:** - User management (`users:view`, `users:create`, `users:edit`, `users:delete`)\n- **roles:** - Role management (`roles:view`, `roles:create`, `roles:edit`, `roles:delete`, `roles:assign`)\n- **permissions:** - Permission management (`permissions:view`, `permissions:create`, etc.)\n- **system:** - System configuration (`system:settings`, `system:logs`, `system:manage`)\n\n#### Authorization Checks\n\n**In Controllers:**\n```elixir\n# Protect individual actions\nplug AuthorizationPlug, {:permission, \"users:edit\"}\nplug AuthorizationPlug, {:role, \"admin\"}\nplug AuthorizationPlug, {:any_permission, [\"users:create\", \"users:edit\"]}\nplug AuthorizationPlug, {:all_permissions, [\"users:edit\", \"system:manage\"]}\n\n# Manual checks\nif can?(conn, \"users:edit\") do\n  # User can edit users\nend\n\nif has_role?(conn, \"admin\") do\n  # User has admin role\nend\n```\n\n**In Context:**\n```elixir\n# Direct checks\nAuthorization.can?(user, \"users:edit\")\nAuthorization.has_role?(user, \"admin\")\nAuthorization.role_has_permission?(role, permission)\n\n# Flexible checks\nAuthorization.can_by?(user: user, permission: \"system:manage\")\nAuthorization.can_by?(user: user, role: \"admin\")\n\n# Get data\nAuthorization.get_user_roles(user)\nAuthorization.get_user_permissions(user)\nAuthorization.get_role_permissions(role)\n```\n\n#### Roles and Permissions API\n\n**Role Management:**\n```bash\nGET    /api/roles              # List roles\nPOST   /api/roles              # Create role\nGET    /api/roles/:id          # Get specific role\nPUT    /api/roles/:id          # Update role\nDELETE /api/roles/:id          # Delete role\n\n# Role assignment to users\nPOST   /api/users/:user_id/roles/:role_id     # Assign role\nDELETE /api/users/:user_id/roles/:role_id     # Remove role\n```\n\n**Permission Management:**\n```bash\nGET    /api/permissions         # List permissions\nPOST   /api/permissions         # Create permission\nGET    /api/permissions/:id     # Get specific permission\nPUT    /api/permissions/:id     # Update permission\nDELETE /api/permissions/:id     # Delete permission\n\n# Permission assignment to roles\nPOST   /api/roles/:role_id/permissions/:perm_id     # Assign permission\nDELETE /api/roles/:role_id/permissions/:perm_id     # Remove permission\n```\n\n**Current User Information:**\n```bash\nGET /api/me  # Includes roles and permissions of authenticated user\n```\n\n#### Seed Data\nWhen running `mix ecto.reset` or `mix run priv/repo/seeds.exs`, the following are automatically created:\n\n- **3 roles** with hierarchy (admin → manager → user)\n- **17 permissions** categorized by functionality\n- **Administrator user** (`admin@admin.com` / `password123!!`) with admin role\n\n#### JWT Integration\nJWT tokens automatically include:\n- User roles list (`\"roles\": [\"admin\", \"manager\"]`)\n- Effective permissions list (`\"permissions\": [\"users:view\", \"users:create\", ...]`)\n\n#### Authorization Helpers\nAvailable in all controllers and views:\n```elixir\ncan?(conn, \"permission:slug\")           # Has specific permission?\nhas_role?(conn, \"role_slug\")           # Has specific role?\ncan_any?(conn, [\"perm1\", \"perm2\"])     # Has any of these permissions?\ncan_all?(conn, [\"perm1\", \"perm2\"])     # Has all these permissions?\ncurrent_user_roles(conn)               # Current user roles\ncurrent_user_permissions(conn)         # Current user permissions\nauthorize(conn, permission: \"users:edit\") # Flexible verification\n```","ref":"readme.html#role-based-access-control-rbac"},{"type":"extras","title":"WebSockets - Rephi","doc":"WebSocket connection is established at `ws://localhost:4000/socket` with user-specific channels.\n\n**✅ Security**: WebSocket connections validate the JWT token before allowing connection. Invalid or missing tokens are automatically rejected.","ref":"readme.html#websockets"},{"type":"extras","title":"Testing - Rephi","doc":"```bash\n# Run backend tests\nmix test\n\n# Run with coverage\nmix test --cover\n```","ref":"readme.html#testing"},{"type":"extras","title":"Deployment - Rephi","doc":"","ref":"readme.html#deployment"},{"type":"extras","title":"Building for Production - Rephi","doc":"```bash\n# Backend\nMIX_ENV=prod mix compile\nMIX_ENV=prod mix assets.deploy\n\n# Frontends\nmix frontends.build\n```","ref":"readme.html#building-for-production"},{"type":"extras","title":"Docker Support - Rephi","doc":"```bash\ndocker build -t rephi .\ndocker run -p 4000:4000 rephi\n```","ref":"readme.html#docker-support"},{"type":"extras","title":"Publishing to Hex.pm - Rephi","doc":"1. Update the version in `mix.exs`\n2. Update `CHANGELOG.md` with release notes\n3. Ensure tests pass: `mix test`\n4. Create git tag: `git tag -a v0.1.0 -m \"Release v0.1.0\"`\n5. Publish: `mix hex.publish`","ref":"readme.html#publishing-to-hex-pm"},{"type":"extras","title":"Contributing - Rephi","doc":"1. Fork the repository\n2. Create your feature branch (`git checkout -b feature/amazing-feature`)\n3. Commit your changes (`git commit -m 'Add some amazing feature'`)\n4. Push to the branch (`git push origin feature/amazing-feature`)\n5. Open a Pull Request","ref":"readme.html#contributing"},{"type":"extras","title":"License - Rephi","doc":"This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]\n\n## [0.0.2] - 2024-06-22","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Initial release\n- JWT authentication system with Guardian\n- Complete RBAC (Role-Based Access Control) implementation\n- WebSocket support with Phoenix Channels\n- Multi-frontend architecture support\n- Swagger/OpenAPI documentation\n- CSRF protection for SPAs\n- Default roles and permissions seeding\n- Frontend build integration with Mix tasks\n- Dashboard, Admin, E-commerce, and Landing page structure","ref":"changelog.html#added"},{"type":"extras","title":"Security - Changelog","doc":"- JWT tokens include user roles and permissions\n- CSRF token injection in SPA HTML\n- WebSocket connections validate JWT tokens\n- Hierarchical permission system\n\n[0.0.2]: https://github.com/thotenn/rephi/releases/tag/v0.0.2","ref":"changelog.html#security"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2024 thotenn\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}